=== added file '.hgignore'
--- .hgignore	1970-01-01 00:00:00 +0000
+++ .hgignore	2007-09-12 20:22:04 +0000
@@ -0,0 +1,6 @@
+syntax: glob
+*~
+*.pyc
+build
+dist
+flup.egg-info

=== modified file 'ChangeLog'
--- ChangeLog	2006-11-28 18:53:39 +0000
+++ ChangeLog	2007-09-12 20:22:04 +0000
@@ -1,47 +1,107 @@
-2006-11-26  Allan Saddi  <asaddi@europa.saddi.net>
+2007-09-10  Allan Saddi  <allan@saddi.com>
+
+	* Fix readline implementations so size argument is checked
+	  earlier.
+
+2007-07-14  Allan Saddi  <allan@saddi.com>
+
+	* Prevent ThreadPool inconsistences if an exception is
+	  actually raised. Thanks to Tim Chen for the patch.
+
+2007-06-05  Allan Saddi  <allan@saddi.com>
+
+	* Remove publisher and middleware packages.
+	* Add cgi server for completeness.
+
+2007-05-17  Allan Saddi  <allan@saddi.com>
+
+	* Fix fcgi_fork so it can run on Solaris. Thanks to
+	  Basil Crow for the patch.
+
+2007-01-22  Allan Saddi  <allan@saddi.com>
+
+	* Fix eunuchs import issue.
+
+2007-01-10  Allan Saddi  <allan@saddi.com>
+
+	* Support gzip compression of XHTML pages using the
+	  correct MIME type.
+
+2006-12-29  Allan Saddi  <allan@saddi.com>
+
+	* Deprecate WSGI_SCRIPT_NAME and scriptName in scgi_base.
+	  Modern versions of mod_scgi correctly set SCRIPT_NAME &
+	  PATH_INFO.
+
+2006-12-13  Allan Saddi  <allan@saddi.com>
+
+	* Fix problem in session.py seen when optimization is on.
+
+2006-12-05  Allan Saddi  <allan@saddi.com>
+
+	* Update servers to default to an empty QUERY_STRING if
+	  not present in the environ.
+	* Update gzip.py: compresslevel -> compress_level
+	* Update gzip.py by updating docstrings and renaming
+	  classes/methods/functions to better follow Python naming
+	  conventions. NB: mimeTypes keyword parameter is now
+	  mime_types.
+
+2006-12-02  Allan Saddi  <allan@saddi.com>
+
+	* Change intra-package imports into absolute imports.
+
+2006-12-02  Allan Saddi  <allan@saddi.com>
+
+	* Add forceCookieOutput attribute to SessionService to
+	  force Set-Cookie output for the current request.
+
+2006-12-01  Allan Saddi  <allan@saddi.com>
+
+	* Update setup script.
+
+2006-11-26  Allan Saddi  <allan@saddi.com>
 
 	* Don't attempt to install signal handlers under Windows
 	  to improve compatibility.
 
-2006-11-24  Allan Saddi  <asaddi@europa.saddi.net>
+2006-11-24  Allan Saddi  <allan@saddi.com>
 
 	* Add *_thread egg entry-point aliases.
-
 	* Add UNIX domain socket support to scgi, scgi_fork,
 	  scgi_app.
-
 	* Add flup.client package which contains various
 	  WSGI -> connector client implentations. (So far: FastCGI,
 	  and SCGI.)
 
-2006-11-19  Allan Saddi  <asaddi@europa.saddi.net>
+2006-11-19  Allan Saddi  <allan@saddi.com>
 
 	* Change mime-type matching algorithm in GzipMiddleware.
 	  Strip parameters (e.g. "encoding") and accept a list of
 	  regexps. By default, compress 'text/.*' mime-types.
 
-2006-11-10  Allan Saddi  <asaddi@europa.saddi.net>
+2006-11-10  Allan Saddi  <allan@saddi.com>
 
 	* Add cookieAttributes to SessionService to make it easier
 	  to customize the generated cookie's attributes.
 
-2006-08-28  Allan Saddi  <asaddi@sahara.flup.org>
+2006-08-28  Allan Saddi  <allan@saddi.com>
 
 	* Add support for FastCGI roles other than FCGI_RESPONDER.
 	  Patch provided by Seairth Jacobs.
 
-2006-08-02  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-08-02  Allan Saddi  <allan@saddi.com>
 
 	* Add cookieExpiration keyword to SessionService /
 	  SessionMiddleware to adjust the session cookie's expiration.
 	  Thanks to Blaise Laflamme for the suggestion.
 
-2006-06-27  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-06-27  Allan Saddi  <allan@saddi.com>
 
 	* Set close-on-exec flag on all server sockets. Thanks to
 	  Ralf Schmitt for reporting the problem.
 
-2006-06-18  Allan Saddi  <asaddi@europa.saddi.net>
+2006-06-18  Allan Saddi  <allan@saddi.com>
 
 	* Stop ignoring EPIPE exceptions, as this is probably the
 	  wrong thing to do. (Application is unaware of disconnected
@@ -52,28 +112,28 @@
 	  NB: Existing applications that use the flup servers may begin
 	  seeing socket.error exceptions...
 
-2006-05-18  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-05-18  Allan Saddi  <allan@saddi.com>
 
 	* Added umask keyword parameter to fcgi and fcgi_fork,
 	  for use when binding to a UNIX socket.
 
-2006-05-03  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-05-03  Allan Saddi  <allan@saddi.com>
 
 	* Fix illusive problem with AJP implementation. Thanks to
 	  Moshe Van der Sterre for explaining the problem and
 	  providing a fix.
 
-2006-04-06  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-04-06  Allan Saddi  <allan@saddi.com>
 
 	* Catch a strange FieldStorage case. Seen in production.
 	  Not quite sure what causes it.
 
-2006-03-21  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-03-21  Allan Saddi  <allan@saddi.com>
 
 	* Add maxRequests option to PreforkServer. Patch provided by
 	  Wojtek Sobczuk.
 
-2006-02-23  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-02-23  Allan Saddi  <allan@saddi.com>
 
 	* Add paste.server_factory-compliant factories and respective
 	  egg entry points. Thanks to Luis Bruno for the code.
@@ -81,25 +141,25 @@
 	  Add debug option to servers, which is True by default.
 	  Currently, only server-level error handling is affected.
 	
-2006-01-15  Allan Saddi  <asaddi@ganymede.saddi.net>
+2006-01-15  Allan Saddi  <allan@saddi.com>
 
 	* Change the behavior of ImportingModuleResolver when dealing
 	  with ImportErrors. Previously, it would act as if the module
 	  did not exist. Now, it propagates the exception to another
 	  level (outer middleware or WSGI). Reported by Scot Doyle.
 
-2006-01-05  Allan Saddi  <asaddi@kalahari.flup.org>
+2006-01-05  Allan Saddi  <allan@saddi.com>
 
 	* Improve Windows compatibility by conditionally installing
 	  SIGHUP handler. Thanks to Brad Miller for pointing out the
 	  problem and providing a fix.
 
-2005-12-19  Allan Saddi  <asaddi@kalahari.flup.org>
+2005-12-19  Allan Saddi  <allan@saddi.com>
 
 	* Fix socket leak in eunuchs socketpair() wrapper. Thanks to
 	  Georg Bauer for pointing this out.
 
-2005-12-16  Allan Saddi  <asaddi@kalahari.flup.org>
+2005-12-16  Allan Saddi  <allan@saddi.com>
 
 	* Switch to setuptools for egg support.
 	* Add higher-level 404 error page support. Thanks to Scot Doyle
@@ -108,17 +168,17 @@
 	  is now broken. It will have to be massaged to fit the new
 	  calling convention.
 
-2005-11-28  Allan Saddi  <asaddi@kalahari.flup.org>
+2005-11-28  Allan Saddi  <allan@saddi.com>
 
 	* Fix issue with FCGI_GET_VALUES handling. Thanks to
 	  Timothy Wright for pointing this out.
 
-2005-11-18  Allan Saddi  <asaddi@kalahari.flup.org>
+2005-11-18  Allan Saddi  <allan@saddi.com>
 
 	* When running under Python < 2.4, attempt to use socketpair()
 	  from eunuchs module.
 
-2005-09-07  Allan Saddi  <asaddi@europa.saddi.net>
+2005-09-07  Allan Saddi  <allan@saddi.com>
 
 	* Python 2.3 doesn't define socket.SHUT_WR, which affected
 	  the closing of the FastCGI socket with the server. This would
@@ -126,25 +186,25 @@
 	  the problem to my attention and going out of his way to help
 	  me debug it!
 
-2005-07-03  Allan Saddi  <asaddi@europa.saddi.net>
+2005-07-03  Allan Saddi  <allan@saddi.com>
 
 	* Ensure session identifiers only contain ASCII characters when
 	  using a non-ASCII locale. Thanks to Ksenia Marasanova for the
 	  the fix.
 
-2005-06-12  Allan Saddi  <asaddi@europa.saddi.net>
+2005-06-12  Allan Saddi  <allan@saddi.com>
 
 	* Cleanly close connection socket to avoid sending a TCP RST to
 	  the web server. (fcgi_base) Fix suggested by Dima Barsky.
 
-2005-05-31  Allan Saddi  <asaddi@ganymede.saddi.net>
+2005-05-31  Allan Saddi  <allan@saddi.com>
 
 	* Take scriptName from the WSGI_SCRIPT_NAME environment variable
 	  passed from the web server, if present.
 	* Check if scriptName is None, and if so, don't modify SCRIPT_NAME
 	  & PATH_INFO. For better compatibility with cgi2scgi. (scgi_base)
 
-2005-05-18  Allan Saddi  <asaddi@ganymede.saddi.net>
+2005-05-18  Allan Saddi  <allan@saddi.com>
 
 	* Change default allowedServers for ajp and scgi to ['127.0.0.1'].
 	* Accept PATH_INFO from environment for scgi servers, in case
@@ -153,20 +213,18 @@
 	  Allow it to be changed by keyword argument.
 	* Fix wsgi.multiprocess for scgi_fork. (Set to True.)
 
-2005-05-15  Allan Saddi  <asaddi@ganymede.saddi.net>
+2005-05-15  Allan Saddi  <allan@saddi.com>
 
 	* Prevent possible deadlock related to DiskSessionStore locking.
 	* Add logic to SessionStore so that it will block if attempting to
 	  check out a Session that's already been checked out.
 
-2005-05-14  Allan Saddi  <asaddi@ganymede.saddi.net>
+2005-05-14  Allan Saddi  <allan@saddi.com>
 
 	* Convert the use of decorators in session.py to something
 	  compatible with Python <2.4.
 
-2005-04-23  Allan Saddi  <asaddi@ganymede.saddi.net>
+2005-04-23  Allan Saddi  <allan@saddi.com>
 
 	* Ensure that SessionStore.checkOutSession() never returns an
 	  invalidated Session. Reported by Rene Dudfield.
-
-

=== removed file 'MANIFEST.in'
--- MANIFEST.in	2006-06-28 13:43:41 +0000
+++ MANIFEST.in	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-include ChangeLog

=== added file 'PKG-INFO'
--- PKG-INFO	1970-01-01 00:00:00 +0000
+++ PKG-INFO	2007-09-12 20:22:04 +0000
@@ -0,0 +1,18 @@
+Metadata-Version: 1.0
+Name: flup
+Version: 1.0
+Summary: Random assortment of WSGI servers
+Home-page: http://www.saddi.com/software/flup/
+Author: Allan Saddi
+Author-email: allan@saddi.com
+License: BSD
+Description: UNKNOWN
+Platform: UNKNOWN
+Classifier: Development Status :: 5 - Production/Stable
+Classifier: Environment :: Web Environment
+Classifier: Intended Audience :: Developers
+Classifier: License :: OSI Approved :: BSD License
+Classifier: Operating System :: OS Independent
+Classifier: Programming Language :: Python
+Classifier: Topic :: Internet :: WWW/HTTP :: WSGI :: Server
+Classifier: Topic :: Software Development :: Libraries :: Python Modules

=== modified file 'debian/changelog'
--- debian/changelog	2006-11-28 18:53:39 +0000
+++ debian/changelog	2007-09-12 20:22:04 +0000
@@ -1,3 +1,20 @@
+flup (1.0-1) unstable; urgency=low
+
+  * New upstream release
+  * http://www.saddi.com/software/news/archives/58-flup-1.0-released.html
+  * Added a note in the description that people should probably start thinking
+    of moving to modwsgi.org
+
+ -- Kai Hendry <hendry@iki.fi>  Wed, 12 Sep 2007 20:22:04 +0100
+
+flup (0.2307-1) unstable; urgency=low
+
+  * New upstream release
+  * Rebuild with egg support (Closes: #409250)
+  * Thanks to POX on #debian-python for the clean find rule
+
+ -- Kai Hendry <hendry@iki.fi>  Fri,  2 Feb 2007 12:16:42 +0000
+
 flup (0.2126-1) unstable; urgency=low
 
   * New upstream release

=== modified file 'debian/control'
--- debian/control	2006-06-28 13:43:41 +0000
+++ debian/control	2007-09-12 20:22:04 +0000
@@ -2,7 +2,7 @@
 Section: python
 Priority: optional
 Maintainer: Kai Hendry <hendry@iki.fi>
-Build-Depends: debhelper (>= 5.0.37.2), python-support (>= 0.3), python-dev
+Build-Depends: debhelper (>= 5.0.37.2), python-support (>= 0.3), python-dev, python-setuptools
 Standards-Version: 3.7.2
 XS-Python-Version: >= 2.4
 
@@ -19,4 +19,7 @@
   * FastCGI, see http://www.fastcgi.com/
   * SCGI - Simple Common Gateway Interface alternative
  .
+ Flup has been superseded by modwsgi.org, which is currently implemented
+ as an apache2 module in the "libapache2-mod-wsgi" package
+ .
  Homepage: http://www.saddi.com/software/flup/

=== modified file 'debian/rules'
--- debian/rules	2006-06-28 13:43:41 +0000
+++ debian/rules	2007-09-12 20:22:04 +0000
@@ -5,14 +5,15 @@
 	dh_testdir
 	dh_testroot
 	python setup.py clean
+	find . -name *\.py[co] -exec rm {} \;
 	rm -rf build
-	dh_clean 
+	dh_clean
 
 build: #blank
 install: build
 	dh_testdir
 	dh_testroot
-	dh_clean -k 
+	dh_clean -k
 	dh_installdirs
 	python setup.py install --no-compile --root=debian/python-flup/
 

=== added file 'ez_setup.py'
--- ez_setup.py	1970-01-01 00:00:00 +0000
+++ ez_setup.py	2007-09-12 20:22:04 +0000
@@ -0,0 +1,231 @@
+#!python
+"""Bootstrap setuptools installation
+
+If you want to use setuptools in your package's setup.py, just include this
+file in the same directory with it, and add this to the top of your setup.py::
+
+    from ez_setup import use_setuptools
+    use_setuptools()
+
+If you want to require a specific version of setuptools, set a download
+mirror, or use an alternate download directory, you can do so by supplying
+the appropriate options to ``use_setuptools()``.
+
+This file can also be run as a script to install or upgrade setuptools.
+"""
+import sys
+DEFAULT_VERSION = "0.6c6"
+DEFAULT_URL     = "http://cheeseshop.python.org/packages/%s/s/setuptools/" % sys.version[:3]
+
+md5_data = {
+    'setuptools-0.6b1-py2.3.egg': '8822caf901250d848b996b7f25c6e6ca',
+    'setuptools-0.6b1-py2.4.egg': 'b79a8a403e4502fbb85ee3f1941735cb',
+    'setuptools-0.6b2-py2.3.egg': '5657759d8a6d8fc44070a9d07272d99b',
+    'setuptools-0.6b2-py2.4.egg': '4996a8d169d2be661fa32a6e52e4f82a',
+    'setuptools-0.6b3-py2.3.egg': 'bb31c0fc7399a63579975cad9f5a0618',
+    'setuptools-0.6b3-py2.4.egg': '38a8c6b3d6ecd22247f179f7da669fac',
+    'setuptools-0.6b4-py2.3.egg': '62045a24ed4e1ebc77fe039aa4e6f7e5',
+    'setuptools-0.6b4-py2.4.egg': '4cb2a185d228dacffb2d17f103b3b1c4',
+    'setuptools-0.6c1-py2.3.egg': 'b3f2b5539d65cb7f74ad79127f1a908c',
+    'setuptools-0.6c1-py2.4.egg': 'b45adeda0667d2d2ffe14009364f2a4b',
+    'setuptools-0.6c2-py2.3.egg': 'f0064bf6aa2b7d0f3ba0b43f20817c27',
+    'setuptools-0.6c2-py2.4.egg': '616192eec35f47e8ea16cd6a122b7277',
+    'setuptools-0.6c3-py2.3.egg': 'f181fa125dfe85a259c9cd6f1d7b78fa',
+    'setuptools-0.6c3-py2.4.egg': 'e0ed74682c998bfb73bf803a50e7b71e',
+    'setuptools-0.6c3-py2.5.egg': 'abef16fdd61955514841c7c6bd98965e',
+    'setuptools-0.6c4-py2.3.egg': 'b0b9131acab32022bfac7f44c5d7971f',
+    'setuptools-0.6c4-py2.4.egg': '2a1f9656d4fbf3c97bf946c0a124e6e2',
+    'setuptools-0.6c4-py2.5.egg': '8f5a052e32cdb9c72bcf4b5526f28afc',
+    'setuptools-0.6c5-py2.3.egg': 'ee9fd80965da04f2f3e6b3576e9d8167',
+    'setuptools-0.6c5-py2.4.egg': 'afe2adf1c01701ee841761f5bcd8aa64',
+    'setuptools-0.6c5-py2.5.egg': 'a8d3f61494ccaa8714dfed37bccd3d5d',
+    'setuptools-0.6c6-py2.3.egg': '35686b78116a668847237b69d549ec20',
+    'setuptools-0.6c6-py2.4.egg': '3c56af57be3225019260a644430065ab',
+    'setuptools-0.6c6-py2.5.egg': 'b2f8a7520709a5b34f80946de5f02f53',
+}
+
+import sys, os
+
+def _validate_md5(egg_name, data):
+    if egg_name in md5_data:
+        from md5 import md5
+        digest = md5(data).hexdigest()
+        if digest != md5_data[egg_name]:
+            print >>sys.stderr, (
+                "md5 validation of %s failed!  (Possible download problem?)"
+                % egg_name
+            )
+            sys.exit(2)
+    return data
+
+
+def use_setuptools(
+    version=DEFAULT_VERSION, download_base=DEFAULT_URL, to_dir=os.curdir,
+    download_delay=15
+):
+    """Automatically find/download setuptools and make it available on sys.path
+
+    `version` should be a valid setuptools version number that is available
+    as an egg for download under the `download_base` URL (which should end with
+    a '/').  `to_dir` is the directory where setuptools will be downloaded, if
+    it is not already available.  If `download_delay` is specified, it should
+    be the number of seconds that will be paused before initiating a download,
+    should one be required.  If an older version of setuptools is installed,
+    this routine will print a message to ``sys.stderr`` and raise SystemExit in
+    an attempt to abort the calling script.
+    """
+    try:
+        import setuptools
+        if setuptools.__version__ == '0.0.1':
+            print >>sys.stderr, (
+            "You have an obsolete version of setuptools installed.  Please\n"
+            "remove it from your system entirely before rerunning this script."
+            )
+            sys.exit(2)
+    except ImportError:
+        egg = download_setuptools(version, download_base, to_dir, download_delay)
+        sys.path.insert(0, egg)
+        import setuptools; setuptools.bootstrap_install_from = egg
+
+    import pkg_resources
+    try:
+        pkg_resources.require("setuptools>="+version)
+
+    except pkg_resources.VersionConflict, e:
+        # XXX could we install in a subprocess here?
+        print >>sys.stderr, (
+            "The required version of setuptools (>=%s) is not available, and\n"
+            "can't be installed while this script is running. Please install\n"
+            " a more recent version first.\n\n(Currently using %r)"
+        ) % (version, e.args[0])
+        sys.exit(2)
+
+def download_setuptools(
+    version=DEFAULT_VERSION, download_base=DEFAULT_URL, to_dir=os.curdir,
+    delay = 15
+):
+    """Download setuptools from a specified location and return its filename
+
+    `version` should be a valid setuptools version number that is available
+    as an egg for download under the `download_base` URL (which should end
+    with a '/'). `to_dir` is the directory where the egg will be downloaded.
+    `delay` is the number of seconds to pause before an actual download attempt.
+    """
+    import urllib2, shutil
+    egg_name = "setuptools-%s-py%s.egg" % (version,sys.version[:3])
+    url = download_base + egg_name
+    saveto = os.path.join(to_dir, egg_name)
+    src = dst = None
+    if not os.path.exists(saveto):  # Avoid repeated downloads
+        try:
+            from distutils import log
+            if delay:
+                log.warn("""
+---------------------------------------------------------------------------
+This script requires setuptools version %s to run (even to display
+help).  I will attempt to download it for you (from
+%s), but
+you may need to enable firewall access for this script first.
+I will start the download in %d seconds.
+
+(Note: if this machine does not have network access, please obtain the file
+
+   %s
+
+and place it in this directory before rerunning this script.)
+---------------------------------------------------------------------------""",
+                    version, download_base, delay, url
+                ); from time import sleep; sleep(delay)
+            log.warn("Downloading %s", url)
+            src = urllib2.urlopen(url)
+            # Read/write all in one block, so we don't create a corrupt file
+            # if the download is interrupted.
+            data = _validate_md5(egg_name, src.read())
+            dst = open(saveto,"wb"); dst.write(data)
+        finally:
+            if src: src.close()
+            if dst: dst.close()
+    return os.path.realpath(saveto)
+
+def main(argv, version=DEFAULT_VERSION):
+    """Install or upgrade setuptools and EasyInstall"""
+
+    try:
+        import setuptools
+    except ImportError:
+        egg = None
+        try:
+            egg = download_setuptools(version, delay=0)
+            sys.path.insert(0,egg)
+            from setuptools.command.easy_install import main
+            return main(list(argv)+[egg])   # we're done here
+        finally:
+            if egg and os.path.exists(egg):
+                os.unlink(egg)
+    else:
+        if setuptools.__version__ == '0.0.1':
+            # tell the user to uninstall obsolete version
+            use_setuptools(version)
+
+    req = "setuptools>="+version
+    import pkg_resources
+    try:
+        pkg_resources.require(req)
+    except pkg_resources.VersionConflict:
+        try:
+            from setuptools.command.easy_install import main
+        except ImportError:
+            from easy_install import main
+        main(list(argv)+[download_setuptools(delay=0)])
+        sys.exit(0) # try to force an exit
+    else:
+        if argv:
+            from setuptools.command.easy_install import main
+            main(argv)
+        else:
+            print "Setuptools version",version,"or greater has been installed."
+            print '(Run "ez_setup.py -U setuptools" to reinstall or upgrade.)'
+
+
+
+def update_md5(filenames):
+    """Update our built-in md5 registry"""
+
+    import re
+    from md5 import md5
+
+    for name in filenames:
+        base = os.path.basename(name)
+        f = open(name,'rb')
+        md5_data[base] = md5(f.read()).hexdigest()
+        f.close()
+
+    data = ["    %r: %r,\n" % it for it in md5_data.items()]
+    data.sort()
+    repl = "".join(data)
+
+    import inspect
+    srcfile = inspect.getsourcefile(sys.modules[__name__])
+    f = open(srcfile, 'rb'); src = f.read(); f.close()
+
+    match = re.search("\nmd5_data = {\n([^}]+)}", src)
+    if not match:
+        print >>sys.stderr, "Internal error!"
+        sys.exit(2)
+
+    src = src[:match.start(1)] + repl + src[match.end(1):]
+    f = open(srcfile,'w')
+    f.write(src)
+    f.close()
+
+
+if __name__=='__main__':
+    if len(sys.argv)>2 and sys.argv[1]=='--md5update':
+        update_md5(sys.argv[2:])
+    else:
+        main(sys.argv[1:])
+
+
+
+
+

=== added directory 'flup.egg-info'
=== added file 'flup.egg-info/PKG-INFO'
--- flup.egg-info/PKG-INFO	1970-01-01 00:00:00 +0000
+++ flup.egg-info/PKG-INFO	2007-09-12 20:22:04 +0000
@@ -0,0 +1,18 @@
+Metadata-Version: 1.0
+Name: flup
+Version: 1.0
+Summary: Random assortment of WSGI servers
+Home-page: http://www.saddi.com/software/flup/
+Author: Allan Saddi
+Author-email: allan@saddi.com
+License: BSD
+Description: UNKNOWN
+Platform: UNKNOWN
+Classifier: Development Status :: 5 - Production/Stable
+Classifier: Environment :: Web Environment
+Classifier: Intended Audience :: Developers
+Classifier: License :: OSI Approved :: BSD License
+Classifier: Operating System :: OS Independent
+Classifier: Programming Language :: Python
+Classifier: Topic :: Internet :: WWW/HTTP :: WSGI :: Server
+Classifier: Topic :: Software Development :: Libraries :: Python Modules

=== added file 'flup.egg-info/SOURCES.txt'
--- flup.egg-info/SOURCES.txt	1970-01-01 00:00:00 +0000
+++ flup.egg-info/SOURCES.txt	2007-09-12 20:22:04 +0000
@@ -0,0 +1,30 @@
+.hgignore
+ChangeLog
+ez_setup.py
+setup.cfg
+setup.py
+flup/__init__.py
+flup.egg-info/PKG-INFO
+flup.egg-info/SOURCES.txt
+flup.egg-info/dependency_links.txt
+flup.egg-info/entry_points.txt
+flup.egg-info/top_level.txt
+flup.egg-info/zip-safe
+flup/client/__init__.py
+flup/client/fcgi_app.py
+flup/client/scgi_app.py
+flup/server/__init__.py
+flup/server/ajp.py
+flup/server/ajp_base.py
+flup/server/ajp_fork.py
+flup/server/cgi.py
+flup/server/fcgi.py
+flup/server/fcgi_base.py
+flup/server/fcgi_fork.py
+flup/server/paste_factory.py
+flup/server/preforkserver.py
+flup/server/scgi.py
+flup/server/scgi_base.py
+flup/server/scgi_fork.py
+flup/server/threadedserver.py
+flup/server/threadpool.py

=== added file 'flup.egg-info/dependency_links.txt'
--- flup.egg-info/dependency_links.txt	1970-01-01 00:00:00 +0000
+++ flup.egg-info/dependency_links.txt	2007-09-12 20:22:04 +0000
@@ -0,0 +1,1 @@
+

=== added file 'flup.egg-info/entry_points.txt'
--- flup.egg-info/entry_points.txt	1970-01-01 00:00:00 +0000
+++ flup.egg-info/entry_points.txt	2007-09-12 20:22:04 +0000
@@ -0,0 +1,12 @@
+
+    [paste.server_factory]
+    ajp = flup.server.ajp:factory
+    fcgi = flup.server.fcgi:factory
+    scgi = flup.server.scgi:factory
+    ajp_thread = flup.server.ajp:factory
+    fcgi_thread = flup.server.fcgi:factory
+    scgi_thread = flup.server.scgi:factory
+    ajp_fork = flup.server.ajp_fork:factory
+    fcgi_fork = flup.server.fcgi_fork:factory
+    scgi_fork = flup.server.scgi_fork:factory
+    
\ No newline at end of file

=== added file 'flup.egg-info/top_level.txt'
--- flup.egg-info/top_level.txt	1970-01-01 00:00:00 +0000
+++ flup.egg-info/top_level.txt	2007-09-12 20:22:04 +0000
@@ -0,0 +1,1 @@
+flup

=== added file 'flup.egg-info/zip-safe'
--- flup.egg-info/zip-safe	1970-01-01 00:00:00 +0000
+++ flup.egg-info/zip-safe	2007-09-12 20:22:04 +0000
@@ -0,0 +1,1 @@
+

=== removed directory 'flup/middleware'
=== removed file 'flup/middleware/__init__.py'
--- flup/middleware/__init__.py	2006-06-28 13:43:41 +0000
+++ flup/middleware/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-#

=== removed file 'flup/middleware/error.py'
--- flup/middleware/error.py	2006-06-28 13:43:41 +0000
+++ flup/middleware/error.py	1970-01-01 00:00:00 +0000
@@ -1,352 +0,0 @@
-# Copyright (c) 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: error.py 1753 2005-04-15 01:33:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1753 $'
-
-import sys
-import os
-import traceback
-import time
-from email.Message import Message
-from email.MIMEMultipart import MIMEMultipart
-from email.MIMEText import MIMEText
-import smtplib
-
-try:
-    import thread
-except ImportError:
-    import dummy_thread as thread
-
-__all__ = ['ErrorMiddleware']
-
-def _wrapIterator(appIter, errorMiddleware, environ, start_response):
-    """
-    Wrapper around the application's iterator which catches any unhandled
-    exceptions. Forwards close() and __len__ to the application iterator,
-    if necessary.
-    """
-    class metaIterWrapper(type):
-        def __init__(cls, name, bases, clsdict):
-            super(metaIterWrapper, cls).__init__(name, bases, clsdict)
-            if hasattr(appIter, '__len__'):
-                cls.__len__ = appIter.__len__
-
-    class iterWrapper(object):
-        __metaclass__ = metaIterWrapper
-        def __init__(self):
-            self._next = iter(appIter).next
-            if hasattr(appIter, 'close'):
-                self.close = appIter.close
-
-        def __iter__(self):
-            return self
-
-        def next(self):
-            try:
-                return self._next()
-            except StopIteration:
-                raise
-            except:
-                errorMiddleware.exceptionHandler(environ)
-
-                # I'm not sure I like this next part.
-                try:
-                    errorIter = errorMiddleware.displayErrorPage(environ,
-                                                                 start_response)
-                except:
-                    # Headers already sent, what can be done?
-                    raise
-                else:
-                    # The exception occurred early enough for start_response()
-                    # to succeed. Swap iterators!
-                    self._next = iter(errorIter).next
-                    return self._next()
-
-    return iterWrapper()
-
-class ErrorMiddleware(object):
-    """
-    Middleware that catches any unhandled exceptions from the application.
-    Displays a (static) error page to the user while emailing details about
-    the exception to an administrator.
-    """
-    def __init__(self, application, adminAddress,
-                 fromAddress='wsgiapp',
-                 smtpHost='localhost',
-
-                 applicationName=None,
-
-                 errorPageMimeType='text/html',
-                 errorPage=None,
-                 errorPageFile='error.html',
-
-                 emailInterval=15,
-                 intervalCheckFile='errorEmailCheck',
-
-                 debug=False):
-        """
-        Explanation of parameters:
-
-        application - WSGI application.
-
-        adminAddress - Email address of administrator.
-        fromAddress - Email address that the error email should appear to
-          originate from. By default 'wsgiapp@hostname.of.server'.
-        smtpHost - SMTP email server, through which to send the email.
-
-        applicationName - Name of your WSGI application, to help differentiate
-          it from other applications in email. By default, this is the Python
-          name of the application object. (You should explicitly set this
-          if you use other middleware components, otherwise the name
-          deduced will probably be that of a middleware component.)
-
-        errorPageMimeType - MIME type of the static error page. 'text/html'
-          by default.
-        errorPage - String representing the body of the static error page.
-          If None (the default), errorPageFile must point to an existing file.
-        errorPageFile - File from which to take the static error page (may
-          be relative to current directory or an absolute filename).
-
-        emailInterval - Minimum number of minutes between error mailings,
-          to prevent the administrator's mailbox from filling up.
-        intervalCheckFile - When running in one-shot mode (as determined by
-          the 'wsgi.run_once' environment variable), this file is used to
-          keep track of the last time an email was sent. May be relative
-          (to the current directory) or an absolute filename.
-
-        debug - If True, will attempt to display the traceback as a webpage.
-          No email is sent. If False (the default), the static error page is
-          displayed and the error email is sent, if necessary.
-        """
-        self._application = application
-
-        self._adminAddress = adminAddress
-        self._fromAddress = fromAddress
-        self._smtpHost = smtpHost
-
-        # Set up a generic application name if not specified.
-        if applicationName is None:
-            applicationName = []
-            if application.__module__ != '__main__':
-                applicationName.append('%s.' % application.__module__)
-            applicationName.append(application.__name__)
-            applicationName = ''.join(applicationName)
-        self._applicationName = applicationName
-
-        self._errorPageMimeType = errorPageMimeType
-        # If errorPage was unspecified, set it from the static file
-        # specified by errorPageFile.
-        if errorPage is None:
-            f = open(errorPageFile)
-            errorPage = f.read()
-            f.close
-        self._errorPage = errorPage
-
-        self._emailInterval = emailInterval * 60
-        self._lastEmailTime = 0
-        self._intervalCheckFile = intervalCheckFile
-
-        # Set up displayErrorPage appropriately.
-        self._debug = debug
-        if debug:
-            self.displayErrorPage = self._displayDebugPage
-        else:
-            self.displayErrorPage = self._displayErrorPage
-
-        # Lock for _lastEmailTime
-        self._lock = thread.allocate_lock()
-
-    def _displayErrorPage(self, environ, start_response):
-        """
-        Displays the static error page. May be overridden. (Maybe you'd
-        rather redirect or something?) This is basically a mini-WSGI
-        application, except that start_response() is called with the third
-        argument.
-
-        Really, there's nothing keeping you from overriding this method
-        and displaying a dynamic error page. But I thought it might be safer
-        to display a static page. :)
-        """
-        start_response('200 OK', [('Content-Type', self._errorPageMimeType),
-                                  ('Content-Length',
-                                   str(len(self._errorPage)))],
-                       sys.exc_info())
-        return [self._errorPage]
-
-    def _displayDebugPage(self, environ, start_response):
-        """
-        When debugging, display an informative traceback of the exception.
-        """
-        import cgitb
-        result = [cgitb.html(sys.exc_info())]
-        start_response('200 OK', [('Content-Type', 'text/html'),
-                                  ('Content-Length', str(len(result[0])))],
-                       sys.exc_info())
-        return result
-
-    def _generateHTMLErrorEmail(self):
-        """
-        Generates the HTML version of the error email. Must return a string.
-        """
-        import cgitb
-        return cgitb.html(sys.exc_info())
-
-    def _generatePlainErrorEmail(self):
-        """
-        Generates the plain-text version of the error email. Must return a
-        string.
-        """
-        import cgitb
-        return cgitb.text(sys.exc_info())
-
-    def _generateErrorEmail(self):
-        """
-        Generates the error email. Must return an instance of email.Message
-        or subclass.
-
-        This implementation generates a MIME multipart/alternative email with
-        an HTML description of the error and a simpler plain-text alternative
-        of the traceback.
-        """
-        msg = MIMEMultipart('alternative')
-        msg.attach(MIMEText(self._generatePlainErrorEmail()))
-        msg.attach(MIMEText(self._generateHTMLErrorEmail(), 'html'))
-        return msg
-
-    def _sendErrorEmail(self, environ):
-        """
-        Sends the error email as generated by _generateErrorEmail(). If
-        anything goes wrong sending the email, the exception is caught
-        and reported to wsgi.errors. I don't think there's really much else
-        that can be done in that case.
-        """
-        msg = self._generateErrorEmail()
-
-        msg['From'] = self._fromAddress
-        msg['To'] = self._adminAddress
-        msg['Subject'] = '%s: unhandled exception' % self._applicationName
-
-        try:
-            server = smtplib.SMTP(self._smtpHost)
-            server.sendmail(self._fromAddress, self._adminAddress,
-                            msg.as_string())
-            server.quit()
-        except Exception, e:
-            stderr = environ['wsgi.errors']
-            stderr.write('%s: Failed to send error email: %r %s\n' %
-                         (self.__class__.__name__, e, e))
-            stderr.flush()
-
-    def _shouldSendEmail(self, environ):
-        """
-        Returns True if an email should be sent. The last time an email was
-        sent is tracked by either an instance variable (if oneShot is False),
-        or the mtime of a file on the filesystem (if oneShot is True).
-        """
-        if self._debug or self._adminAddress is None:
-            # Never send email when debugging or when there's no admin
-            # address.
-            return False
-
-        now = time.time()
-        if not environ['wsgi.run_once']:
-            self._lock.acquire()
-            ret = (self._lastEmailTime + self._emailInterval) < now
-            if ret:
-                self._lastEmailTime = now
-            self._lock.release()
-        else:
-            # The following should be protected, but do I *really* want
-            # to get into the mess of using filesystem and file-based locks?
-            # At worse, multiple emails get sent.
-            ret = True
-
-            try:
-                mtime = os.path.getmtime(self._intervalCheckFile)
-            except:
-                # Assume file doesn't exist, which is OK. Send email
-                # unconditionally.
-                pass
-            else:
-                if (mtime + self._emailInterval) >= now:
-                    ret = False
-
-            if ret:
-                # NB: If _intervalCheckFile cannot be created or written to
-                # for whatever reason, you will *always* get an error email.
-                try:
-                    open(self._intervalCheckFile, 'w').close()
-                except:
-                    # Probably a good idea to report failure.
-                    stderr = environ['wsgi.errors']
-                    stderr.write('%s: Error writing intervalCheckFile %r\n'
-                                 % (self.__class__.__name__,
-                                    self._intervalCheckFile))
-                    stderr.flush()
-        return ret
-
-    def exceptionHandler(self, environ):
-        """
-        Common handling of exceptions.
-        """
-        # Unconditionally report to wsgi.errors.
-        stderr = environ['wsgi.errors']
-        traceback.print_exc(file=stderr)
-        stderr.flush()
-
-        # Send error email, if needed.
-        if self._shouldSendEmail(environ):
-            self._sendErrorEmail(environ)
-
-    def __call__(self, environ, start_response):
-        """
-        WSGI application interface. Simply wraps the call to the application
-        with a try ... except. All the fancy stuff happens in the except
-        clause.
-        """
-        try:
-            return _wrapIterator(self._application(environ, start_response),
-                                 self, environ, start_response)
-        except:
-            # Report the exception.
-            self.exceptionHandler(environ)
-
-            # Display static error page.
-            return self.displayErrorPage(environ, start_response)
-
-if __name__ == '__main__':
-    def myapp(environ, start_response):
-        start_response('200 OK', [('Content-Type', 'text/plain')])
-        raise RuntimeError, "I'm broken!"
-        return ['Hello World!\n']
-
-    # Note - email address is taken from sys.argv[1]. I'm not leaving
-    # my email address here. ;)
-    app = ErrorMiddleware(myapp, sys.argv[1])
-
-    from ajp import WSGIServer
-    WSGIServer(app).run()

=== removed file 'flup/middleware/gzip.py'
--- flup/middleware/gzip.py	2006-11-28 18:53:39 +0000
+++ flup/middleware/gzip.py	1970-01-01 00:00:00 +0000
@@ -1,252 +0,0 @@
-# Copyright (c) 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: gzip.py 2106 2006-11-19 17:34:30Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2106 $'
-
-import struct
-import time
-import zlib
-import re
-
-__all__ = ['GzipMiddleware']
-
-# This gzip middleware component differentiates itself from others in that
-# it (hopefully) follows the spec more closely. Namely with regard to the
-# application iterator and buffering. (It doesn't buffer.)
-# See <http://www.python.org/peps/pep-0333.html#middleware-handling-of-block-boundaries>
-#
-# Of course this all comes with a price... just LOOK at this mess! :)
-#
-# The inner workings of gzip and the gzip file format were gleaned from gzip.py
-
-def _gzipHeader():
-    """Returns a gzip header (with no filename)."""
-    # See GzipFile._write_gzip_header in gzip.py
-    return '\037\213' \
-           '\010' \
-           '\0' + \
-           struct.pack('<L', long(time.time())) + \
-           '\002' \
-           '\377'
-
-class _iterWrapper(object):
-    """
-    gzip iterator wrapper. It ensures that: the application iterator's close()
-    method (if any) is called by the parent server; and at least one value
-    is yielded each time the application's iterator yields a value.
-
-    If the application's iterator yields N values, this iterator will yield
-    N+1 values. This is to account for the gzip trailer.
-    """
-    def __init__(self, appIter, gzipMiddleware):
-        self._g = gzipMiddleware
-        self._next = iter(appIter).next
-
-        self._last = False # True if appIter has yielded last value.
-        self._trailerSent = False
-
-        if hasattr(appIter, 'close'):
-            self.close = appIter.close
-
-    def __iter__(self):
-        return self
-
-    # This would've been a lot easier had I used a generator. But then I'd have
-    # to wrap the generator anyway to ensure that any existing close() method
-    # was called. (Calling it within the generator is not the same thing,
-    # namely it does not ensure that it will be called no matter what!)
-    def next(self):
-        if not self._last:
-            # Need to catch StopIteration here so we can append trailer.
-            try:
-                data = self._next()
-            except StopIteration:
-                self._last = True
-
-        if not self._last:
-            if self._g.gzipOk:
-                return self._g.gzipData(data)
-            else:
-                return data
-        else:
-            # See if trailer needs to be sent.
-            if self._g.headerSent and not self._trailerSent:
-                self._trailerSent = True
-                return self._g.gzipTrailer()
-            # Otherwise, that's the end of this iterator.
-            raise StopIteration
-
-class _gzipMiddleware(object):
-    """
-    The actual gzip middleware component. Holds compression state as well
-    implementations of start_response and write. Instantiated before each
-    call to the underlying application.
-
-    This class is private. See GzipMiddleware for the public interface.
-    """
-    def __init__(self, start_response, mimeTypes, compresslevel):
-        self._start_response = start_response
-        self._mimeTypes = mimeTypes
-
-        self.gzipOk = False
-        self.headerSent = False
-
-        # See GzipFile.__init__ and GzipFile._init_write in gzip.py
-        self._crc = zlib.crc32('')
-        self._size = 0
-        self._compress = zlib.compressobj(compresslevel,
-                                          zlib.DEFLATED,
-                                          -zlib.MAX_WBITS,
-                                          zlib.DEF_MEM_LEVEL,
-                                          0)
-
-    def gzipData(self, data):
-        """
-        Compresses the given data, prepending the gzip header if necessary.
-        Returns the result as a string.
-        """
-        if not self.headerSent:
-            self.headerSent = True
-            out = _gzipHeader()
-        else:
-            out = ''
-
-        # See GzipFile.write in gzip.py
-        length = len(data)
-        if length > 0:
-            self._size += length
-            self._crc = zlib.crc32(data, self._crc)
-            out += self._compress.compress(data)
-        return out
-        
-    def gzipTrailer(self):
-        # See GzipFile.close in gzip.py
-        return self._compress.flush() + \
-               struct.pack('<l', self._crc) + \
-               struct.pack('<L', self._size & 0xffffffffL)
-
-    def start_response(self, status, headers, exc_info=None):
-        self.gzipOk = False
-
-        # Scan the headers. Only allow gzip compression if the Content-Type
-        # is one that we're flagged to compress AND the headers do not
-        # already contain Content-Encoding.
-        for name,value in headers:
-            name = name.lower()
-            if name == 'content-type':
-                value = value.split(';')[0].strip()
-                for p in self._mimeTypes:
-                    if p.match(value) is not None:
-                        self.gzipOk = True
-                        break
-            elif name == 'content-encoding':
-                self.gzipOk = False
-                break
-
-        if self.gzipOk:
-            # Remove Content-Length, if present, because compression will
-            # most surely change it. (And unfortunately, we can't predict
-            # the final size...)
-            headers = [(name,value) for name,value in headers
-                       if name.lower() != 'content-length']
-            headers.append(('Content-Encoding', 'gzip'))
-
-        _write = self._start_response(status, headers, exc_info)
-
-        if self.gzipOk:
-            def write_gzip(data):
-                _write(self.gzipData(data))
-            return write_gzip
-        else:
-            return _write
-
-class GzipMiddleware(object):
-    """
-    WSGI middleware component that gzip compresses the application's output
-    (if the client supports gzip compression - gleaned  from the
-    Accept-Encoding request header).
-
-    mimeTypes should be a list of Content-Types that are OK to compress.
-
-    compresslevel is the gzip compression level, an integer from 1 to 9; 1
-    is the fastest and produces the least compression, and 9 is the slowest,
-    producing the most compression.
-    """
-    def __init__(self, application, mimeTypes=None, compresslevel=9):
-        if mimeTypes is None:
-            mimeTypes = ['text/.*']
-
-        self._application = application
-        self._mimeTypes = [re.compile(m) for m in mimeTypes]
-        self._compresslevel = compresslevel
-
-    def __call__(self, environ, start_response):
-        """WSGI application interface."""
-        # If the client doesn't support gzip encoding, just pass through
-        # directly to the application.
-        if 'gzip' not in environ.get('HTTP_ACCEPT_ENCODING', ''):
-            return self._application(environ, start_response)
-
-        # All of the work is done in _gzipMiddleware and _iterWrapper.
-        g = _gzipMiddleware(start_response, self._mimeTypes,
-                            self._compresslevel)
-
-        result = self._application(environ, g.start_response)
-
-        # See if it's a length 1 iterable...
-        try:
-            shortcut = len(result) == 1
-        except:
-            shortcut = False
-
-        if shortcut:
-            # Special handling if application returns a length 1 iterable:
-            # also return a length 1 iterable!
-            try:
-                i = iter(result)
-                # Hmmm, if we get a StopIteration here, the application's
-                # broken (__len__ lied!)
-                data = i.next()
-                if g.gzipOk:
-                    return [g.gzipData(data) + g.gzipTrailer()]
-                else:
-                    return [data]
-            finally:
-                if hasattr(result, 'close'):
-                    result.close()
-
-        return _iterWrapper(result, g)
-
-if __name__ == '__main__':
-    def myapp(environ, start_response):
-        start_response('200 OK', [('Content-Type', 'text/html')])
-        return ['Hello World!\n']
-    app = GzipMiddleware(myapp)
-
-    from ajp import WSGIServer
-    import logging
-    WSGIServer(app, loggingLevel=logging.DEBUG).run()

=== removed file 'flup/middleware/session.py'
--- flup/middleware/session.py	2006-11-28 18:53:39 +0000
+++ flup/middleware/session.py	1970-01-01 00:00:00 +0000
@@ -1,766 +0,0 @@
-# Copyright (c) 2005, 2006 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: session.py 2104 2006-11-11 00:38:26Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2104 $'
-
-import os
-import errno
-import string
-import time
-import weakref
-import atexit
-import shelve
-import cPickle as pickle
-
-try:
-    import threading
-except ImportError:
-    import dummy_threading as threading
-
-__all__ = ['Session',
-           'SessionStore',
-           'MemorySessionStore',
-           'ShelveSessionStore',
-           'DiskSessionStore',
-           'SessionMiddleware']
-
-class Session(dict):
-    """
-    Session objects, basically dictionaries.
-    """
-    identifierLength = 32
-    # Would be nice if len(identifierChars) were some power of 2.
-    identifierChars = string.digits + string.ascii_letters + '-_'
-
-    def __init__(self, identifier):
-        super(Session, self).__init__()
-
-        assert self.isIdentifierValid(identifier)
-        self._identifier = identifier
-
-        self._creationTime = self._lastAccessTime = time.time()
-        self._isValid = True
-
-    def _get_identifier(self):
-        return self._identifier
-    identifier = property(_get_identifier, None, None,
-                          'Unique identifier for Session within its Store')
-
-    def _get_creationTime(self):
-        return self._creationTime
-    creationTime = property(_get_creationTime, None, None,
-                            'Time when Session was created')
-
-    def _get_lastAccessTime(self):
-        return self._lastAccessTime
-    lastAccessTime = property(_get_lastAccessTime, None, None,
-                              'Time when Session was last accessed')
-
-    def _get_isValid(self):
-        return self._isValid
-    isValid = property(_get_isValid, None, None,
-                       'Whether or not this Session is valid')
-
-    def touch(self):
-        """Update Session's access time."""
-        self._lastAccessTime = time.time()
-
-    def invalidate(self):
-        """Invalidate this Session."""
-        self.clear()
-        self._creationTime = self._lastAccessTime = 0
-        self._isValid = False
-
-    def isIdentifierValid(cls, ident):
-        """
-        Returns whether or not the given string *could be* a valid session
-        identifier.
-        """
-        if type(ident) is str and len(ident) == cls.identifierLength:
-            for c in ident:
-                if c not in cls.identifierChars:
-                    return False
-            return True
-        return False
-    isIdentifierValid = classmethod(isIdentifierValid)
-
-    def generateIdentifier(cls):
-        """
-        Generate a random session identifier.
-        """
-        raw = os.urandom(cls.identifierLength)
-
-        sessId = ''
-        for c in raw:
-            # So we lose 2 bits per random byte...
-            sessId += cls.identifierChars[ord(c) % len(cls.identifierChars)]
-        return sessId
-    generateIdentifier = classmethod(generateIdentifier)
-
-def _shutdown(ref):
-    store = ref()
-    if store is not None:
-        store.shutdown()
-
-class SessionStore(object):
-    """
-    Abstract base class for session stores. You first acquire a session by
-    calling createSession() or checkOutSession(). After using the session,
-    you must call checkInSession(). You must not keep references to sessions
-    outside of a check in/check out block. Always obtain a fresh reference.
-
-    Some external mechanism must be set up to call periodic() periodically
-    (perhaps every 5 minutes).
-
-    After timeout minutes of inactivity, sessions are deleted.
-    """
-    _sessionClass = Session
-
-    def __init__(self, timeout=60, sessionClass=None):
-        self._lock = threading.Condition()
-
-        # Timeout in minutes
-        self._sessionTimeout = timeout
-
-        if sessionClass is not None:
-            self._sessionClass = sessionClass
-
-        self._checkOutList = {}
-        self._shutdownRan = False
-
-        # Ensure shutdown is called.
-        atexit.register(_shutdown, weakref.ref(self))
-
-    # Public interface.
-
-    def createSession(self):
-        """
-        Create a new session with a unique identifier. Should never fail.
-        (Will raise a RuntimeError in the rare event that it does.)
-
-        The newly-created session should eventually be released by
-        a call to checkInSession().
-        """
-        assert not self._shutdownRan
-        self._lock.acquire()
-        try:
-            attempts = 0
-            while attempts < 10000:
-                sessId = self._sessionClass.generateIdentifier()
-                sess = self._createSession(sessId)
-                if sess is not None: break
-                attempts += 1
-
-            if attempts >= 10000:
-                raise RuntimeError, self.__class__.__name__ + \
-                      '.createSession() failed'
-
-            assert sess.identifier not in self._checkOutList
-            self._checkOutList[sess.identifier] = sess
-            return sess
-        finally:
-            self._lock.release()
-
-    def checkOutSession(self, identifier):
-        """
-        Checks out a session for use. Returns the session if it exists,
-        otherwise returns None. If this call succeeds, the session
-        will be touch()'ed and locked from use by other processes.
-        Therefore, it should eventually be released by a call to
-        checkInSession().
-        """
-        assert not self._shutdownRan
-
-        if not self._sessionClass.isIdentifierValid(identifier):
-            return None
-
-        self._lock.acquire()
-        try:
-            # If we know it's already checked out, block.
-            while identifier in self._checkOutList:
-                self._lock.wait()
-            sess = self._loadSession(identifier)
-            if sess is not None:
-                if sess.isValid:
-                    assert sess.identifier not in self._checkOutList
-                    self._checkOutList[sess.identifier] = sess
-                    sess.touch()
-                else:
-                    # No longer valid (same as not existing). Delete/unlock
-                    # the session.
-                    self._deleteSession(sess.identifier)
-                    sess = None
-            return sess
-        finally:
-            self._lock.release()
-
-    def checkInSession(self, session):
-        """
-        Returns the session for use by other threads/processes. Safe to
-        pass None.
-        """
-        assert not self._shutdownRan
-
-        if session is None:
-            return
-
-        self._lock.acquire()
-        try:
-            assert session.identifier in self._checkOutList
-            if session.isValid:
-                self._saveSession(session)
-            else:
-                self._deleteSession(session.identifier)
-            del self._checkOutList[session.identifier]
-            self._lock.notify()
-        finally:
-            self._lock.release()
-
-    def shutdown(self):
-        """Clean up outstanding sessions."""
-        self._lock.acquire()
-        try:
-            if not self._shutdownRan:
-                # Save or delete any sessions that are still out there.
-                for key,sess in self._checkOutList.items():
-                    if sess.isValid:
-                        self._saveSession(sess)
-                    else:
-                        self._deleteSession(sess.identifier)
-                self._checkOutList.clear()
-                self._shutdown()
-                self._shutdownRan = True
-        finally:
-            self._lock.release()
-
-    def __del__(self):
-        self.shutdown()
-
-    def periodic(self):
-        """Timeout old sessions. Should be called periodically."""
-        self._lock.acquire()
-        try:
-            if not self._shutdownRan:
-                self._periodic()
-        finally:
-            self._lock.release()
-
-    # To be implemented by subclasses. self._lock will be held whenever
-    # these are called and for methods that take an identifier,
-    # the identifier will be guaranteed to be valid (but it will not
-    # necessarily exist).
-
-    def _createSession(self, identifier):
-        """
-        Attempt to create the session with the given identifier. If
-        successful, return the newly-created session, which must
-        also be implicitly locked from use by other processes. (The
-        session returned should be an instance of self._sessionClass.)
-        If unsuccessful, return None.
-        """
-        raise NotImplementedError, self.__class__.__name__ + '._createSession'
-        
-    def _loadSession(self, identifier):
-        """
-        Load the session with the identifier from secondary storage returning
-        None if it does not exist. If the load is successful, the session
-        must be locked from use by other processes.
-        """
-        raise NotImplementedError, self.__class__.__name__ + '._loadSession'
-
-    def _saveSession(self, session):
-        """
-        Store the session into secondary storage. Also implicitly releases
-        the session for use by other processes.
-        """
-        raise NotImplementedError, self.__class__.__name__ + '._saveSession'
-
-    def _deleteSession(self, identifier):
-        """
-        Deletes the session from secondary storage. Must be OK to pass
-        in an invalid (non-existant) identifier. If the session did exist,
-        it must be released for use by other processes.
-        """
-        raise NotImplementedError, self.__class__.__name__ + '._deleteSession'
-
-    def _periodic(self):
-        """Remove timedout sessions from secondary storage."""
-        raise NotImplementedError, self.__class__.__name__ + '._periodic'
-        
-    def _shutdown(self):
-        """Performs necessary shutdown actions for secondary store."""
-        raise NotImplementedError, self.__class__.__name__ + '._shutdown'
-
-    # Utilities
-
-    def _isSessionTimedout(self, session, now=time.time()):
-        return (session.lastAccessTime + self._sessionTimeout * 60) < now
-    
-class MemorySessionStore(SessionStore):
-    """
-    Memory-based session store. Great for persistent applications, terrible
-    for one-shot ones. :)
-    """
-    def __init__(self, *a, **kw):
-        super(MemorySessionStore, self).__init__(*a, **kw)
-
-        # Our "secondary store".
-        self._secondaryStore = {}
-
-    def _createSession(self, identifier):
-        if self._secondaryStore.has_key(identifier):
-            return None
-        sess = self._sessionClass(identifier)
-        self._secondaryStore[sess.identifier] = sess
-        return sess
-
-    def _loadSession(self, identifier):
-        return self._secondaryStore.get(identifier, None)
-
-    def _saveSession(self, session):
-        self._secondaryStore[session.identifier] = session
-
-    def _deleteSession(self, identifier):
-        if self._secondaryStore.has_key(identifier):
-            del self._secondaryStore[identifier]
-
-    def _periodic(self):
-        now = time.time()
-        for key,sess in self._secondaryStore.items():
-            if self._isSessionTimedout(sess, now):
-                del self._secondaryStore[key]
-        
-    def _shutdown(self):
-        pass
-
-class ShelveSessionStore(SessionStore):
-    """
-    Session store based on Python "shelves." Only use if you can guarantee
-    that storeFile will NOT be accessed concurrently by other instances.
-    (In other processes, threads, anywhere!)
-    """
-    def __init__(self, storeFile='sessions', *a, **kw):
-        super(ShelveSessionStore, self).__init__(*a, **kw)
-
-        self._secondaryStore = shelve.open(storeFile,
-                                           protocol=pickle.HIGHEST_PROTOCOL)
-
-    def _createSession(self, identifier):
-        if self._secondaryStore.has_key(identifier):
-            return None
-        sess = self._sessionClass(identifier)
-        self._secondaryStore[sess.identifier] = sess
-        return sess
-
-    def _loadSession(self, identifier):
-        return self._secondaryStore.get(identifier, None)
-
-    def _saveSession(self, session):
-        self._secondaryStore[session.identifier] = session
-
-    def _deleteSession(self, identifier):
-        if self._secondaryStore.has_key(identifier):
-            del self._secondaryStore[identifier]
-
-    def _periodic(self):
-        now = time.time()
-        for key,sess in self._secondaryStore.items():
-            if self._isSessionTimedout(sess, now):
-                del self._secondaryStore[key]
-        
-    def _shutdown(self):
-        self._secondaryStore.close()
-
-class DiskSessionStore(SessionStore):
-    """
-    Disk-based session store that stores each session as its own file
-    within a specified directory. Should be safe for concurrent use.
-    (As long as the underlying OS/filesystem respects create()'s O_EXCL.)
-    """
-    def __init__(self, storeDir='sessions', *a, **kw):
-        super(DiskSessionStore, self).__init__(*a, **kw)
-
-        self._sessionDir = storeDir
-        if not os.access(self._sessionDir, os.F_OK):
-            # Doesn't exist, try to create it.
-            os.mkdir(self._sessionDir)
-
-    def _filenameForSession(self, identifier):
-        return os.path.join(self._sessionDir, identifier + '.sess')
-
-    def _lockSession(self, identifier, block=True):
-        # Release SessionStore lock so we don't deadlock.
-        self._lock.release()
-        try:
-            fn = self._filenameForSession(identifier) + '.lock'
-            while True:
-                try:
-                    fd = os.open(fn, os.O_WRONLY|os.O_CREAT|os.O_EXCL)
-                except OSError, e:
-                    if e.errno != errno.EEXIST:
-                        raise
-                else:
-                    os.close(fd)
-                    break
-
-                if not block:
-                    return False
-
-                # See if the lock is stale. If so, remove it.
-                try:
-                    now = time.time()
-                    mtime = os.path.getmtime(fn)
-                    if (mtime + 60) < now:
-                        os.unlink(fn)
-                except OSError, e:
-                    if e.errno != errno.ENOENT:
-                        raise
-
-                time.sleep(0.1)
-
-            return True
-        finally:
-            self._lock.acquire()
-
-    def _unlockSession(self, identifier):
-        fn = self._filenameForSession(identifier) + '.lock'
-        os.unlink(fn) # Need to catch errors?
-
-    def _createSession(self, identifier):
-        fn = self._filenameForSession(identifier)
-        lfn = fn + '.lock'
-        # Attempt to create the file's *lock* first.
-        lfd = fd = -1
-        try:
-            lfd = os.open(lfn, os.O_WRONLY|os.O_CREAT|os.O_EXCL)
-            fd = os.open(fn, os.O_WRONLY|os.O_CREAT|os.O_EXCL)
-        except OSError, e:
-            if e.errno == errno.EEXIST:
-                if lfd >= 0:
-                    # Remove lockfile.
-                    os.close(lfd)
-                    os.unlink(lfn)
-                return None
-            raise
-        else:
-            # Success.
-            os.close(fd)
-            os.close(lfd)
-            return self._sessionClass(identifier)
-
-    def _loadSession(self, identifier, block=True):
-        if not self._lockSession(identifier, block):
-            return None
-        try:
-            return pickle.load(open(self._filenameForSession(identifier)))
-        except:
-            self._unlockSession(identifier)
-            return None
-
-    def _saveSession(self, session):
-        f = open(self._filenameForSession(session.identifier), 'w+')
-        pickle.dump(session, f, protocol=pickle.HIGHEST_PROTOCOL)
-        f.close()
-        self._unlockSession(session.identifier)
-
-    def _deleteSession(self, identifier):
-        try:
-            os.unlink(self._filenameForSession(identifier))
-        except:
-            pass
-        self._unlockSession(identifier)
-
-    def _periodic(self):
-        now = time.time()
-        sessions = os.listdir(self._sessionDir)
-        for name in sessions:
-            if not name.endswith('.sess'):
-                continue
-            identifier = name[:-5]
-            if not self._sessionClass.isIdentifierValid(identifier):
-                continue
-            # Not very efficient.
-            sess = self._loadSession(identifier, block=False)
-            if sess is None:
-                continue
-            if self._isSessionTimedout(sess, now):
-                self._deleteSession(identifier)
-            else:
-                self._unlockSession(identifier)
-
-    def _shutdown(self):
-        pass
-
-# SessionMiddleware stuff.
-
-from Cookie import SimpleCookie
-import cgi
-import urlparse
-
-class SessionService(object):
-    """
-    WSGI extension API passed to applications as
-    environ['com.saddi.service.session'].
-
-    Public API: (assume service = environ['com.saddi.service.session'])
-      service.session - Returns the Session associated with the client.
-      service.hasSession - True if the client is currently associated with
-        a Session.
-      service.isSessionNew - True if the Session was created in this
-        transaction.
-      service.hasSessionExpired - True if the client is associated with a
-        non-existent Session.
-      service.encodesSessionInURL - True if the Session ID should be encoded in
-        the URL. (read/write)
-      service.encodeURL(url) - Returns url encoded with Session ID (if
-        necessary).
-      service.cookieAttributes - Dictionary of additional RFC2109 attributes
-        to be added to the generated cookie.
-    """
-    _expiredSessionIdentifier = 'expired session'
-
-    def __init__(self, store, environ,
-                 cookieName='_SID_',
-                 cookieExpiration=None, # Deprecated
-                 cookieAttributes={},
-                 fieldName='_SID_'):
-        self._store = store
-        self._cookieName = cookieName
-        self._cookieExpiration = cookieExpiration
-        self.cookieAttributes = dict(cookieAttributes)
-        self._fieldName = fieldName
-
-        self._session = None
-        self._newSession = False
-        self._expired = False
-        self.encodesSessionInURL = False
-
-        if __debug__: self._closed = False
-
-        self._loadExistingSession(environ)
-
-    def _loadSessionFromCookie(self, environ):
-        """
-        Attempt to load the associated session using the identifier from
-        the cookie.
-        """
-        C = SimpleCookie(environ.get('HTTP_COOKIE'))
-        morsel = C.get(self._cookieName, None)
-        if morsel is not None:
-            self._session = self._store.checkOutSession(morsel.value)
-            self._expired = self._session is None
-
-    def _loadSessionFromQueryString(self, environ):
-        """
-        Attempt to load the associated session using the identifier from
-        the query string.
-        """
-        qs = cgi.parse_qsl(environ.get('QUERY_STRING', ''))
-        for name,value in qs:
-            if name == self._fieldName:
-                self._session = self._store.checkOutSession(value)
-                self._expired = self._session is None
-                self.encodesSessionInURL = True
-                break
-        
-    def _loadExistingSession(self, environ):
-        """Attempt to associate with an existing Session."""
-        # Try cookie first.
-        self._loadSessionFromCookie(environ)
-
-        # Next, try query string.
-        if self._session is None:
-            self._loadSessionFromQueryString(environ)
-
-    def _sessionIdentifier(self):
-        """Returns the identifier of the current session."""
-        assert self._session is not None
-        return self._session.identifier
-
-    def _shouldAddCookie(self):
-        """
-        Returns True if the session cookie should be added to the header
-        (if not encoding the session ID in the URL). The cookie is added if
-        one of these three conditions are true: a) the session was just
-        created, b) the session is no longer valid, or c) the client is
-        associated with a non-existent session.
-        """
-        return self._newSession or \
-               (self._session is not None and not self._session.isValid) or \
-               (self._session is None and self._expired)
-        
-    def addCookie(self, headers):
-        """Adds Set-Cookie header if needed."""
-        if not self.encodesSessionInURL and self._shouldAddCookie():
-            if self._session is not None:
-                sessId = self._sessionIdentifier()
-                expireCookie = not self._session.isValid
-            else:
-                sessId = self._expiredSessionIdentifier
-                expireCookie = True
-
-            C = SimpleCookie()
-            name = self._cookieName
-            C[name] = sessId
-            C[name]['path'] = '/'
-            if self._cookieExpiration is not None:
-                C[name]['expires'] = self._cookieExpiration
-            C[name].update(self.cookieAttributes)
-            if expireCookie:
-                # Expire cookie
-                C[name]['expires'] = -365*24*60*60
-                C[name]['max-age'] = 0
-            headers.append(('Set-Cookie', C[name].OutputString()))
-
-    def close(self):
-        """Checks session back into session store."""
-        if self._session is None:
-            return
-        # Check the session back in and get rid of our reference.
-        self._store.checkInSession(self._session)
-        self._session = None
-        if __debug__: self._closed = True
-
-    # Public API
-
-    def _get_session(self):
-        assert not self._closed
-        if self._session is None:
-            self._session = self._store.createSession()
-            self._newSession = True
-
-        assert self._session is not None
-        return self._session
-    session = property(_get_session, None, None,
-                       'Returns the Session object associated with this '
-                       'client')
-
-    def _get_hasSession(self):
-        assert not self._closed
-        return self._session is not None
-    hasSession = property(_get_hasSession, None, None,
-                          'True if a Session currently exists for this client')
-
-    def _get_isSessionNew(self):
-        assert not self._closed
-        return self._newSession
-    isSessionNew = property(_get_isSessionNew, None, None,
-                            'True if the Session was created in this '
-                            'transaction')
-
-    def _get_hasSessionExpired(self):
-        assert not self._closed
-        return self._expired
-    hasSessionExpired = property(_get_hasSessionExpired, None, None,
-                                 'True if the client was associated with a '
-                                 'non-existent Session')
-
-    # Utilities
-
-    def encodeURL(self, url):
-        """Encodes session ID in URL, if necessary."""
-        assert not self._closed
-        if not self.encodesSessionInURL or self._session is None:
-            return url
-        u = list(urlparse.urlsplit(url))
-        q = '%s=%s' % (self._fieldName, self._sessionIdentifier())
-        if u[3]:
-            u[3] = q + '&' + u[3]
-        else:
-            u[3] = q
-        return urlparse.urlunsplit(u)
-
-def _addClose(appIter, closeFunc):
-    """
-    Wraps an iterator so that its close() method calls closeFunc. Respects
-    the existence of __len__ and the iterator's own close() method.
-
-    Need to use metaclass magic because __len__ and next are not
-    recognized unless they're part of the class. (Can't assign at
-    __init__ time.)
-    """
-    class metaIterWrapper(type):
-        def __init__(cls, name, bases, clsdict):
-            super(metaIterWrapper, cls).__init__(name, bases, clsdict)
-            if hasattr(appIter, '__len__'):
-                cls.__len__ = appIter.__len__
-            cls.next = iter(appIter).next
-            if hasattr(appIter, 'close'):
-                def _close(self):
-                    appIter.close()
-                    closeFunc()
-                cls.close = _close
-            else:
-                cls.close = closeFunc
-
-    class iterWrapper(object):
-        __metaclass__ = metaIterWrapper
-        def __iter__(self):
-            return self
-
-    return iterWrapper()
-
-class SessionMiddleware(object):
-    """
-    WSGI middleware that adds a session service. A SessionService instance
-    is passed to the application in environ['com.saddi.service.session'].
-    A references to this instance should not be saved. (A new instance is
-    instantiated with every call to the application.)
-    """
-    _serviceClass = SessionService
-
-    def __init__(self, store, application, serviceClass=None, **kw):
-        self._store = store
-        self._application = application
-        if serviceClass is not None:
-            self._serviceClass = serviceClass
-        self._serviceKW = kw
-
-    def __call__(self, environ, start_response):
-        service = self._serviceClass(self._store, environ, **self._serviceKW)
-        environ['com.saddi.service.session'] = service
-
-        def my_start_response(status, headers, exc_info=None):
-            service.addCookie(headers)
-            return start_response(status, headers, exc_info)
-
-        try:
-            result = self._application(environ, my_start_response)
-        except:
-            # If anything goes wrong, ensure the session is checked back in.
-            service.close()
-            raise
-
-        # The iterator must be unconditionally wrapped, just in case it
-        # is a generator. (In which case, we may not know that a Session
-        # has been checked out until completion of the first iteration.)
-        return _addClose(result, service.close)
-
-if __name__ == '__main__':
-    mss = MemorySessionStore(timeout=5)
-#    sss = ShelveSessionStore(timeout=5)
-    dss = DiskSessionStore(timeout=5)

=== removed file 'flup/publisher.py'
--- flup/publisher.py	2006-06-28 13:43:41 +0000
+++ flup/publisher.py	1970-01-01 00:00:00 +0000
@@ -1,767 +0,0 @@
-# Copyright (c) 2002, 2005, 2006 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: publisher.py 1853 2006-04-06 23:05:58Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1853 $'
-
-import os
-import inspect
-import cgi
-import types
-from Cookie import SimpleCookie
-
-__all__ = ['Request',
-           'Response',
-           'Transaction',
-           'Publisher',
-           'File',
-           'Action',
-           'Redirect',
-           'InternalRedirect',
-           'getexpected',
-           'trimkw']
-
-class NoDefault(object):
-    """Sentinel object so we can distinguish None in keyword arguments."""
-    pass
-
-class Request(object):
-    """
-    Encapsulates data about the HTTP request.
-
-    Supported attributes that originate from here: (The attributes are
-    read-only, however you may modify the contents of environ.)
-      transaction - Enclosing Transaction object.
-      environ - Environment variables, as passed from WSGI adapter.
-      method - Request method.
-      publisherScriptName - SCRIPT_NAME of Publisher.
-      scriptName - SCRIPT_NAME for request.
-      pathInfo - PATH_INFO for request.
-      form - Dictionary containing data from query string and/or POST request.
-      cookie - Cookie from request.
-    """
-    def __init__(self, transaction, environ):
-        self._transaction = transaction
-
-        self._environ = environ
-        self._publisherScriptName = environ.get('SCRIPT_NAME', '')
-
-        self._form = {}
-        self._parseFormData()
-
-        # Is this safe? Will it ever raise exceptions?
-        self._cookie = SimpleCookie(environ.get('HTTP_COOKIE', None))
-
-    def _parseFormData(self):
-        """
-        Fills self._form with data from a FieldStorage. May be overidden to
-        provide custom form processing. (Like no processing at all!)
-        """
-        # Parse query string and/or POST data.
-        form = FieldStorage(fp=self._environ['wsgi.input'],
-                            environ=self._environ, keep_blank_values=1)
-
-        # Collapse FieldStorage into a simple dict.
-        if form.list is not None:
-            for field in form.list:
-                # Wrap uploaded files
-                if field.filename:
-                    val = File(field)
-                else:
-                    val = field.value
-
-                # Add File/value to args, constructing a list if there are
-                # multiple values.
-                if self._form.has_key(field.name):
-                    self._form[field.name].append(val)
-                else:
-                    self._form[field.name] = [val]
-
-        # Unwrap lists with a single item.
-        for name,val in self._form.items():
-            if len(val) == 1:
-                self._form[name] = val[0]
-
-    def _get_transaction(self):
-        return self._transaction
-    transaction = property(_get_transaction, None, None,
-                           "Transaction associated with this Request")
-    
-    def _get_environ(self):
-        return self._environ
-    environ = property(_get_environ, None, None,
-                       "Environment variables passed from adapter")
-    
-    def _get_method(self):
-        return self._environ['REQUEST_METHOD']
-    method = property(_get_method, None, None,
-                      "Request method")
-    
-    def _get_publisherScriptName(self):
-        return self._publisherScriptName
-    publisherScriptName = property(_get_publisherScriptName, None, None,
-                                   'SCRIPT_NAME of Publisher')
-
-    def _get_scriptName(self):
-        return self._environ.get('SCRIPT_NAME', '')
-    scriptName = property(_get_scriptName, None, None,
-                        "SCRIPT_NAME of request")
-
-    def _get_pathInfo(self):
-        return self._environ.get('PATH_INFO', '')
-    pathInfo = property(_get_pathInfo, None, None,
-                        "PATH_INFO of request")
-
-    def _get_form(self):
-        return self._form
-    form = property(_get_form, None, None,
-                    "Parsed GET/POST data")
-
-    def _get_cookie(self):
-        return self._cookie
-    cookie = property(_get_cookie, None, None,
-                      "Cookie received from client")
-
-class Response(object):
-    """
-    Encapsulates response-related data.
-
-    Supported attributes:
-      transaction - Enclosing Transaction object.
-      status - Response status code (and message).
-      headers - Response headers.
-      cookie - Response cookie.
-      contentType - Content type of body.
-      body - Response body. Must be an iterable that yields strings.
-
-    Since there are multiple ways of passing response info back to
-    Publisher, here is their defined precedence:
-      status - headers['Status'] first, then status
-      cookie - Any values set in this cookie are added to the headers in
-        addition to existing Set-Cookie headers.
-      contentType - headers['Content-Type'] first, then contentType. If
-        neither are specified, defaults to 'text/html'.
-      body - Return of function takes precedence. If function returns None,
-        body is used instead.
-    """
-    _initialHeaders = {
-        'Pragma': 'no-cache',
-        'Cache-Control': 'no-cache'
-        }
-
-    def __init__(self, transaction):
-        self._transaction = transaction
-
-        self._status = '200 OK'
-
-        # Initial response headers.
-        self._headers = header_dict(self._initialHeaders)
-
-        self._cookie = SimpleCookie()
-
-        self.body = []
-
-    def _get_transaction(self):
-        return self._transaction
-    transaction = property(_get_transaction, None, None,
-                           "Transaction associated with this Response")
-    
-    def _get_status(self):
-        status = self._headers.get('Status')
-        if status is not None:
-            return status
-        return self._status
-    def _set_status(self, value):
-        if self._headers.has_key('Status'):
-            self._headers['Status'] = value
-        else:
-            self._status = value
-    status = property(_get_status, _set_status, None,
-                      'Response status')
-
-    def _get_headers(self):
-        return self._headers
-    headers = property(_get_headers, None, None,
-                       "Headers to send in response")
-
-    def _get_cookie(self):
-        return self._cookie
-    cookie = property(_get_cookie, None, None,
-                      "Cookie to send in response")
-
-    def _get_contentType(self):
-        return self._headers.get('Content-Type', 'text/html')
-    def _set_contentType(self, value):
-        self._headers['Content-Type'] = value
-    contentType = property(_get_contentType, _set_contentType, None,
-                           'Content-Type of the response body')
-
-class Transaction(object):
-    """
-    Encapsulates objects associated with a single transaction (Request,
-    Response, and possibly a Session).
-
-    Public attributes: (all read-only)
-      request - Request object.
-      response - Response object.
-
-    If Publisher sits on top of SessionMiddleware, the public API of
-    SessionService is also available through the Transaction object.
-    """
-    _requestClass = Request
-    _responseClass = Response
-
-    def __init__(self, publisher, environ):
-        self._publisher = publisher
-        self._request = self._requestClass(self, environ)
-        self._response = self._responseClass(self)
-
-        # Session support.
-        self._sessionService = environ.get('com.saddi.service.session')
-        if self._sessionService is not None:
-            self.encodeURL = self._sessionService.encodeURL
-
-    def _get_request(self):
-        return self._request
-    request = property(_get_request, None, None,
-                       "Request associated with this Transaction")
-
-    def _get_response(self):
-        return self._response
-    response = property(_get_response, None, None,
-                        "Response associated with this Transaction")
-
-    # Export SessionService API
-
-    def _get_session(self):
-        assert self._sessionService is not None, 'No session service found'
-        return self._sessionService.session
-    session = property(_get_session, None, None,
-                       'Returns the Session object associated with this '
-                       'client')
-
-    def _get_hasSession(self):
-        assert self._sessionService is not None, 'No session service found'
-        return self._sessionService.hasSession
-    hasSession = property(_get_hasSession, None, None,
-                          'True if a Session currently exists for this client')
-
-    def _get_isSessionNew(self):
-        assert self._sessionService is not None, 'No session service found'
-        return self._sessionService.isSessionNew
-    isSessionNew = property(_get_isSessionNew, None, None,
-                            'True if the Session was created in this '
-                            'transaction')
-
-    def _get_hasSessionExpired(self):
-        assert self._sessionService is not None, 'No session service found'
-        return self._sessionService.hasSessionExpired
-    hasSessionExpired = property(_get_hasSessionExpired, None, None,
-                                 'True if the client was associated with a '
-                                 'non-existent Session')
-
-    def _get_encodesSessionInURL(self):
-        assert self._sessionService is not None, 'No session service found'
-        return self._sessionService.encodesSessionInURL
-    def _set_encodesSessionInURL(self, value):
-        assert self._sessionService is not None, 'No session service found'
-        self._sessionService.encodesSessionInURL = value
-    encodesSessionInURL = property(_get_encodesSessionInURL,
-                                   _set_encodesSessionInURL, None,
-                                   'True if the Session ID should be encoded '
-                                   'in the URL')
-
-    def prepare(self):
-        """
-        Called before resolved function is invoked. If overridden,
-        super's prepare() MUST be called and it must be called first.
-        """
-        # Pass form values as keyword arguments.
-        args = dict(self._request.form)
-
-        # Pass Transaction to function if it wants it.
-        args['transaction'] = args['trans'] = self
-
-        self._args = args
-
-    def call(self, func, args):
-        """
-        May be overridden to provide custom exception handling and/or
-        per-request additions, e.g. opening a database connection,
-        starting a transaction, etc.
-        """
-        # Trim down keywords to only what the callable expects.
-        expected, varkw = getexpected(func)
-        trimkw(args, expected, varkw)
-
-        return func(**args)
-
-    def run(self, func):
-        """
-        Execute the function, doing any Action processing and also
-        post-processing the function/Action's return value.
-        """
-        try:
-            # Call the function.
-            result = self.call(func, self._args)
-        except Action, a:
-            # Caught an Action, have it do whatever it does
-            result = a.run(self)
-
-        response = self._response
-        headers = response.headers
-
-        if result is not None:
-            if type(result) in types.StringTypes:
-                assert type(result) is str, 'result cannot be unicode!'
-
-                # Set Content-Length, if needed
-                if not headers.has_key('Content-Length'):
-                    headers['Content-Length'] = str(len(result))
-
-                # Wrap in list for WSGI
-                response.body = [result]
-            else:
-                if __debug__:
-                    try:
-                        iter(result)
-                    except TypeError:
-                        raise AssertionError, 'result not iterable!'
-                response.body = result
-
-        # If result was None, assume response.body was appropriately set.
-
-    def finish(self):
-        """
-        Called after resolved function returns, but before response is
-        sent. If overridden, super's finish() should be called last.
-        """
-        response = self._response
-        headers = response.headers
-
-        # Copy cookie to headers.
-        items = response.cookie.items()
-        items.sort()
-        for name,morsel in items:
-            headers.add('Set-Cookie', morsel.OutputString())
-
-        # If there is a Status header, transfer its value to response.status.
-        # It must not remain in the headers!
-        status = headers.get('Status', NoDefault)
-        if status is not NoDefault:
-            del headers['Status']
-            response.status = status
-
-        code = int(response.status[:3])
-        # Check if it's a response that must not include a body.
-        # (See 4.3 in RFC2068.)
-        if code / 100 == 1 or code in (204, 304):
-            # Remove any trace of the response body, if that's the case.
-            for header,value in headers.items():
-                if header.lower().startswith('content-'):
-                    del headers[header]
-            response.body = []
-        else:
-            if self._request.method == 'HEAD':
-                # HEAD reponse must not return a body (but the headers must be
-                # kept intact).
-                response.body = []
-
-            # Add Content-Type, if missing.
-            if not headers.has_key('Content-Type'):
-                headers['Content-Type'] = response.contentType
-
-        # If we have a close() method, ensure that it is called.
-        if hasattr(self, 'close'):
-            response.body = _addClose(response.body, self.close)
-
-class Publisher(object):
-    """
-    WSGI application that publishes Python functions as web pages. Constructor
-    takes an instance of a concrete subclass of Resolver, which is responsible
-    for mapping requests to functions.
-
-    Query string/POST data values are passed to the function as keyword
-    arguments. If the function does not support variable keywords (e.g.
-    does not have a ** parameter), the function will only be passed
-    keywords which it expects. It is recommended that all keyword parameters
-    have defaults so that missing form data does not raise an exception.
-
-    A Transaction instance is always passed to the function via the
-    "transaction" or "trans" keywords. See the Transaction, Request, and
-    Response classes.
-
-    Valid return types for the function are: a string, None, or an iterable
-    that yields strings. If returning None, it is expected that Response.body
-    has been appropriately set. (It must be an iterable that yields strings.)
-
-    An instance of Publisher itself is the WSGI application.
-    """
-    _transactionClass = Transaction
-
-    def __init__(self, resolver, transactionClass=None, error404=None):
-        self._resolver = resolver
-
-        if transactionClass is not None:
-            self._transactionClass = transactionClass
-
-        if error404 is not None:
-            self._error404 = error404
-
-    def _get_resolver(self):
-        return self._resolver
-    resolver = property(_get_resolver, None, None,
-                        'Associated Resolver for this Publisher')
-
-    def __call__(self, environ, start_response):
-        """
-        WSGI application interface. Creates a Transaction (which does most
-        of the work) and sends the response.
-        """
-        # Set up a Transaction.
-        transaction = self._transactionClass(self, environ)
-
-        # Make any needed preparations.
-        transaction.prepare()
-
-        redirect = False
-
-        while True:
-            # Attempt to resolve the function.
-            func = self._resolver.resolve(transaction.request,
-                                          redirect=redirect)
-            if func is None:
-                func = self._error404
-
-            try:
-                # Call the function.
-                transaction.run(func)
-            except InternalRedirect, r:
-                # Internal redirect. Set up environment and resolve again.
-                environ['SCRIPT_NAME'] = transaction.request.publisherScriptName
-                environ['PATH_INFO'] = r.pathInfo
-                redirect = True
-            else:
-                break
-
-        # Give Transaction a chance to do modify/add to the response.
-        transaction.finish()
-
-        # Transform headers into a list. (Need to pay attention to
-        # multiple values.)
-        responseHeaders = []
-        for key,value in transaction.response.headers.items():
-            if type(value) is list:
-                for v in value:
-                    responseHeaders.append((key, v))
-            else:
-                responseHeaders.append((key, value))
-
-        start_response(transaction.response.status, responseHeaders)
-        return transaction.response.body
-
-    def _error404(self, transaction):
-        """Error page to display when resolver fails."""
-        transaction.response.status = '404 Not Found'
-        request_uri = transaction.request.environ.get('REQUEST_URI')
-        if request_uri is None:
-            request_uri = transaction.request.environ.get('SCRIPT_NAME', '') + \
-                          transaction.request.environ.get('PATH_INFO', '')
-        return ["""<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
-<html><head>
-<title>404 Not Found</title>
-</head><body>
-<h1>Not Found</h1>
-The requested URL %s was not found on this server.<p>
-<hr>
-%s</body></html>
-""" % (request_uri, transaction.request.environ.get('SERVER_SIGNATURE', ''))]
-
-class File(object):
-    """
-    Wrapper so we can identify uploaded files.
-    """
-    def __init__(self, field):
-        self.filename = field.filename
-        self.file = field.file
-        self.type = field.type
-        self.type_options = field.type_options
-        self.headers = field.headers
-        
-class Action(Exception):
-    """
-    Abstract base class for 'Actions', which are just exceptions.
-    Within Publisher, Actions have no inherent meaning and are used
-    as a shortcut to perform specific actions where it's ok for a
-    function to abruptly halt. (Like redirects or displaying an
-    error page.)
-
-    I don't know if using exceptions this way is good form (something
-    tells me no ;) Their usage isn't really required, but they're
-    convenient in some situations.
-    """
-    def run(self, transaction):
-        """Override to perform your action."""
-        raise NotImplementedError, self.__class__.__name__ + '.run'
-
-class Redirect(Action):
-    """
-    Redirect to the given URL.
-    """
-    def __init__(self, url, permanent=False):
-        self._url = url
-        self._permanent = permanent
-
-    def run(self, transaction):
-        response = transaction.response
-        response.status = self._permanent and '301 Moved Permanently' or \
-                          '302 Moved Temporarily'
-        response.headers.reset()
-        response.headers['Location'] = self._url
-        response.contentType = 'text/html'
-        return ["""<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
-<html><head>
-<title>%s</title>
-</head><body>
-<h1>Found</h1>
-<p>The document has moved <a href="%s">here</a>.</p>
-<hr>
-%s</body></html>
-""" % (response.status, self._url,
-       transaction.request.environ.get('SERVER_SIGNATURE', ''))]
-
-class InternalRedirect(Exception):
-    """
-    An internal redirect using a new PATH_INFO (relative to Publisher's
-    SCRIPT_NAME).
-
-    When handling an InternalRedirect, the behavior of all included
-    Resolvers is to expose a larger set of callables (that would normally
-    be hidden). Therefore, it is important that you set pathInfo securely -
-    preferably, it should not depend on any data from the request. Ideally,
-    pathInfo should be a constant string.
-    """
-    def __init__(self, pathInfo):
-        self.pathInfo = pathInfo
-
-class FieldStorage(cgi.FieldStorage):
-    def __init__(self, *args, **kw):
-        """
-        cgi.FieldStorage only parses the query string during a GET or HEAD
-        request. Fix this.
-        """
-        cgi.FieldStorage.__init__(self, *args, **kw)
-
-        environ = kw.get('environ') or os.environ
-        method = environ.get('REQUEST_METHOD', 'GET').upper()
-        if method not in ('GET', 'HEAD'): # cgi.FieldStorage already parsed?
-            qs = environ.get('QUERY_STRING')
-            if qs:
-                if self.list is None:
-                    self.list = []
-                for key,value in cgi.parse_qsl(qs, self.keep_blank_values,
-                                               self.strict_parsing):
-                    self.list.append(cgi.MiniFieldStorage(key, value))
-
-class header_dict(dict):
-    """
-    This is essentially a case-insensitive dictionary, with some additions
-    geared towards supporting HTTP headers (like __str__(), add(), and
-    reset()).
-    """
-    def __init__(self, val=None):
-        """
-        If initialized with an existing dictionary, calling reset() will
-        reset our contents back to that initial dictionary.
-        """
-        dict.__init__(self)
-        self._keymap = {}
-        if val is None:
-            val = {}
-        self.update(val)
-        self._reset_state = dict(val)
-        
-    def __contains__(self, key):
-        return key.lower() in self._keymap
-
-    def __delitem__(self, key):
-        lower_key = key.lower()
-        real_key = self._keymap.get(lower_key)
-        if real_key is None:
-            raise KeyError, key
-        del self._keymap[lower_key]
-        dict.__delitem__(self, real_key)
-
-    def __getitem__(self, key):
-        lower_key = key.lower()
-        real_key = self._keymap.get(lower_key)
-        if real_key is None:
-            raise KeyError, key
-        return dict.__getitem__(self, real_key)
-
-    def __str__(self):
-        """Output as HTTP headers."""
-        s = ''
-        for k,v in self.items():
-            if type(v) is list:
-                for i in v:
-                    s += '%s: %s\n' % (k, i)
-            else:
-                s += '%s: %s\n' % (k, v)
-        return s
-    
-    def __setitem__(self, key, value):
-        lower_key = key.lower()
-        real_key = self._keymap.get(lower_key)
-        if real_key is None:
-            self._keymap[lower_key] = key
-            dict.__setitem__(self, key, value)
-        else:
-            dict.__setitem__(self, real_key, value)
-
-    def clear(self):
-        self._keymap.clear()
-        dict.clear(self)
-
-    def copy(self):
-        c = self.__class__(self)
-        c._reset_state = self._reset_state
-        return c
-
-    def get(self, key, failobj=None):
-        lower_key = key.lower()
-        real_key = self._keymap.get(lower_key)
-        if real_key is None:
-            return failobj
-        return dict.__getitem__(self, real_key)
-    
-    def has_key(self, key):
-        return key.lower() in self._keymap
-
-    def setdefault(self, key, failobj=None):
-        lower_key = key.lower()
-        real_key = self._keymap.get(lower_key)
-        if real_key is None:
-            self._keymap[lower_key] = key
-            dict.__setitem__(self, key, failobj)
-            return failobj
-        else:
-            return dict.__getitem__(self, real_key)
-        
-    def update(self, d):
-        for k,v in d.items():
-            self[k] = v
-            
-    def add(self, key, value):
-        """
-        Add a new header value. Does not overwrite previous value of header
-        (in contrast to __setitem__()).
-        """
-        if self.has_key(key):
-            if type(self[key]) is list:
-                self[key].append(value)
-            else:
-                self[key] = [self[key], value]
-        else:
-            self[key] = value
-
-    def reset(self):
-        """Reset contents to that at the time this instance was created."""
-        self.clear()
-        self.update(self._reset_state)
-
-def _addClose(appIter, closeFunc):
-    """
-    Wraps an iterator so that its close() method calls closeFunc. Respects
-    the existence of __len__ and the iterator's own close() method.
-
-    Need to use metaclass magic because __len__ and next are not
-    recognized unless they're part of the class. (Can't assign at
-    __init__ time.)
-    """
-    class metaIterWrapper(type):
-        def __init__(cls, name, bases, clsdict):
-            super(metaIterWrapper, cls).__init__(name, bases, clsdict)
-            if hasattr(appIter, '__len__'):
-                cls.__len__ = appIter.__len__
-            cls.next = iter(appIter).next
-            if hasattr(appIter, 'close'):
-                def _close(self):
-                    appIter.close()
-                    closeFunc()
-                cls.close = _close
-            else:
-                cls.close = closeFunc
-
-    class iterWrapper(object):
-        __metaclass__ = metaIterWrapper
-        def __iter__(self):
-            return self
-
-    return iterWrapper()
-
-# Utilities which may be useful outside of Publisher? Perhaps for decorators...
-
-def getexpected(func):
-    """
-    Returns as a 2-tuple the passed in object's expected arguments and
-    whether or not it accepts variable keywords.
-    """
-    assert callable(func), 'object not callable'
-
-    if not inspect.isclass(func):
-        # At this point, we assume func is either a function, method, or
-        # callable instance.
-        if not inspect.isfunction(func) and not inspect.ismethod(func):
-            func = getattr(func, '__call__') # When would this fail?
-
-        argspec = inspect.getargspec(func)
-        expected, varkw = argspec[0], argspec[2] is not None
-        if inspect.ismethod(func):
-            expected = expected[1:]
-    else:
-        # A class. Try to figure out the calling conventions of the
-        # constructor.
-        init = getattr(func, '__init__', None)
-        # Sigh, this is getting into the realm of black magic...
-        if init is not None and inspect.ismethod(init):
-            argspec = inspect.getargspec(init)
-            expected, varkw = argspec[0], argspec[2] is not None
-            expected = expected[1:]
-        else:
-            expected, varkw = [], False
-
-    return expected, varkw
-
-def trimkw(kw, expected, varkw):
-    """
-    If necessary, trims down a dictionary of keyword arguments to only
-    what's expected.
-    """
-    if not varkw: # Trimming only necessary if it doesn't accept variable kw
-        for name in kw.keys():
-            if name not in expected:
-                del kw[name]

=== removed directory 'flup/resolver'
=== removed file 'flup/resolver/__init__.py'
--- flup/resolver/__init__.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-from resolver import *
-del resolver

=== removed file 'flup/resolver/complex.py'
--- flup/resolver/complex.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/complex.py	1970-01-01 00:00:00 +0000
@@ -1,112 +0,0 @@
-# Copyright (c) 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: complex.py 1833 2005-12-17 00:58:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1833 $'
-
-import re
-
-from resolver import *
-
-__all__ = ['ComplexResolver']
-
-class ComplexResolver(Resolver):
-    """
-    A meta-Resolver that allows you to "graft" different resolvers at various
-    points in your URL space.
-
-    It works as follows: given a PATH_INFO, it will try all matching
-    resolvers, starting with the most specific. The first function returned
-    by a resolver is returned as the result.
-
-    If no matching resolvers return a function, then the search is
-    considered a failure.
-
-    Assumes that none of the registered resolvers modify environ when
-    they fail to resolve.
-
-    Upon successful resolution, SCRIPT_NAME will contain the path up to
-    and including the resolved function (as determined by the resolver) and
-    PATH_INFO will contain all remaining components.
-    """
-    _slashRE = re.compile(r'''/{2,}''')
-
-    def __init__(self):
-        self.resolverMap = {}
-
-    def _canonicalUrl(self, url):
-        if not url: # Represents default
-            return url
-
-        # Get rid of adjacent slashes
-        url = self._slashRE.sub('/', url)
-
-        # No trailing slash
-        if url.endswith('/'):
-            url = url[:-1]
-
-        # Make sure it starts with a slash
-        if not url.startswith('/'):
-            url = '/' + url
-
-        return url
-
-    def addResolver(self, url, resolver):
-        """
-        Registers a resolver at a particular URL. The empty URL ''
-        represents the default resolver. It will be matched when no
-        other matching resolvers are found.
-        """
-        url = self._canonicalUrl(url)
-        self.resolverMap[url] = resolver
-
-    def removeResolver(self, url):
-        """Removes the resolver at a particular URL."""
-        url = self._canonicalUrl(url)
-        del self.resolverMap[url]
-
-    def resolve(self, request, redirect=False):
-        orig_script_name = request.scriptName
-        orig_path_info = path_info = request.pathInfo
-        path_info = path_info.split(';')[0]
-        path_info = path_info.split('/')
-
-        assert len(path_info) > 0
-        assert not path_info[0]
-
-        while path_info:
-            try_path_info = '/'.join(path_info)
-            resolver = self.resolverMap.get(try_path_info)
-            if resolver is not None:
-                self._updatePath(request, len(path_info) - 1)
-                func = resolver.resolve(request, redirect)
-                if func is not None:
-                    return func
-                request.environ['SCRIPT_NAME'] = orig_script_name
-                request.environ['PATH_INFO'] = orig_path_info
-            path_info.pop()
-
-        return None

=== removed file 'flup/resolver/function.py'
--- flup/resolver/function.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/function.py	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-# Copyright (c) 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: function.py 1833 2005-12-17 00:58:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1833 $'
-
-from resolver import *
-
-__all__ = ['FunctionResolver']
-
-class FunctionResolver(Resolver):
-    """
-    Very basic, almost brain-dead Resolver. Simply resolves to the passed
-    in function, no matter what. :)
-
-    Can be used as a decorator and might actually have uses when used with
-    the ComplexResolver.
-    """
-    def __init__(self, func):
-        self._func = func
-
-    def resolve(self, request, redirect=False):
-        return self._func

=== removed file 'flup/resolver/importingmodule.py'
--- flup/resolver/importingmodule.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/importingmodule.py	1970-01-01 00:00:00 +0000
@@ -1,129 +0,0 @@
-# Copyright (c) 2002, 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: importingmodule.py 1837 2006-01-15 18:20:37Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1837 $'
-
-import sys
-import os
-import imp
-
-from resolver import *
-
-__all__ = ['ImportingModuleResolver']
-
-class NoDefault(object):
-    pass
-
-class ImportingModuleResolver(Resolver):
-    """
-    Constructor takes a directory name or a list of directories. Interprets
-    the first two components of PATH_INFO as 'module/function'. Modules
-    are imported as needed and must reside in the directories specified.
-    Module and function names beginning with underscore are ignored.
-
-    If the 'module' part of PATH_INFO is missing, it is assumed to be
-    self.default_module.
-
-    If the 'function' part of PATH_INFO is missing, it is assumed to be
-    self.index_page.
-
-    Upon successful resolution, appends the module and function names to
-    SCRIPT_NAME and updates PATH_INFO as the remaining components of the path.
-
-    NB: I would recommend explicitly setting all modules' __all__ list.
-    Otherwise, be sure all the names of module-level callables that you
-    don't want exported begin with underscore.
-    """
-    # No default module by default.
-    default_module = None
-    index_page = 'index'
-
-    def __init__(self, path, defaultModule=NoDefault, index=NoDefault):
-        self.path = path
-        if defaultModule is not NoDefault:
-            self.default_module = defaultModule
-        if index is not NoDefault:
-            self.index_page = index
-
-    def resolve(self, request, redirect=False):
-        path_info = request.pathInfo.split(';')[0]
-        path_info = path_info.split('/')
-
-        assert len(path_info) > 0
-        assert not path_info[0]
-
-        while len(path_info) < 3:
-            path_info.append('')
-
-        module_name, func_name = path_info[1:3]
-
-        if not module_name:
-            module_name = self.default_module
-
-        if not func_name:
-            func_name = self.index_page
-
-        module = None
-        if module_name and (module_name[0] != '_' or redirect) and \
-           not module_name.count('.'):
-            module = _import_module(module_name, path=self.path)
-
-        if module is not None:
-            if func_name and (func_name[0] != '_' or redirect):
-                module_all = getattr(module, '__all__', None)
-                if module_all is None or func_name in module_all or redirect:
-                    func = getattr(module, func_name, None)
-                    if callable(func):
-                        self._updatePath(request, 2)
-                        return func
-
-        return None
-
-def _import_module(name, path=None):
-    """
-    Imports a module. If path is None, module will be searched for in
-    sys.path. If path is given (which may be a single string or a list),
-    the module will only be searched for in those directories.
-    """
-    if path is not None and type(path) is not list:
-        path = [path]
-
-    module = sys.modules.get(name)
-    if module is not None:
-        module_file = getattr(module, '__file__')
-        if module_file is None or \
-               (path is not None and os.path.dirname(module_file) not in path):
-            return None
-
-        return module
-
-    fp, pathname, description = imp.find_module(name, path)
-    try:
-        return imp.load_module(name, fp, pathname, description)
-    finally:
-        if fp:
-            fp.close()

=== removed file 'flup/resolver/module.py'
--- flup/resolver/module.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/module.py	1970-01-01 00:00:00 +0000
@@ -1,86 +0,0 @@
-# Copyright (c) 2002, 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: module.py 1833 2005-12-17 00:58:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1833 $'
-
-from resolver import *
-
-__all__ = ['ModuleResolver']
-
-class NoDefault(object):
-    pass
-
-class ModuleResolver(Resolver):
-    """
-    Exposes all top-level callables within a module. The module's __all__
-    attribute is respected, if it exists. Names beginning with underscore
-    are ignored.
-
-    Uses the first component of PATH_INFO as the callable's name and if
-    empty, will instead use self.index_page.
-
-    Upon successful resolution, appends the callable's name to SCRIPT_NAME
-    and updates PATH_INFO as the remaining components of the path.
-
-    NB: I would recommend explicitly setting the module's __all__ list.
-    Otherwise, be sure all the names of module-level callables that you
-    don't want exported begin with underscore.
-    """
-    index_page = 'index'
-    
-    def __init__(self, module, index=NoDefault):
-        self.module = module
-        if index is not NoDefault:
-            self.index_page = index
-
-    def resolve(self, request, redirect=False):
-        path_info = request.pathInfo.split(';')[0]
-        path_info = path_info.split('/')
-
-        assert len(path_info) > 0
-        assert not path_info[0]
-
-        if len(path_info) < 2:
-            path_info.append('')
-
-        func_name = path_info[1]
-
-        if func_name:
-            if func_name[0] == '_' and not redirect:
-                func_name = None
-        else:
-            func_name = self.index_page
-
-        if func_name:
-            module_all = getattr(self.module, '__all__', None)
-            if module_all is None or func_name in module_all or redirect:
-                func = getattr(self.module, func_name, None)
-                if callable(func):
-                    self._updatePath(request, 1)
-                    return func
-                
-        return None

=== removed file 'flup/resolver/nopathinfo.py'
--- flup/resolver/nopathinfo.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/nopathinfo.py	1970-01-01 00:00:00 +0000
@@ -1,57 +0,0 @@
-# Copyright (c) 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: nopathinfo.py 1833 2005-12-17 00:58:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1833 $'
-
-from resolver import *
-
-__all__ = ['NoPathInfoResolver']
-
-class NoPathInfoResolver(Resolver):
-    """
-    Another meta-resolver. Disallows the existence of PATH_INFO (beyond
-    what's needed to resolve the function). Optionally allows a trailing
-    slash.
-    """
-    def __init__(self, resolver, allowTrailingSlash=False):
-        self._resolver = resolver
-        self._allowTrailingSlash = allowTrailingSlash
-
-    def resolve(self, request, redirect=False):
-        orig_script_name, orig_path_info = request.scriptName, request.pathInfo
-        func = self._resolver.resolve(request, redirect)
-        try:
-            if func is not None:
-                path_info = request.pathInfo.split(';')[0]
-                if path_info and \
-                   (not self._allowTrailingSlash or path_info != '/'):
-                    func = None
-            return func
-        finally:
-            if func is None:
-                request.environ['SCRIPT_NAME'] = orig_script_name
-                request.environ['PATH_INFO'] = orig_path_info

=== removed file 'flup/resolver/objectpath.py'
--- flup/resolver/objectpath.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/objectpath.py	1970-01-01 00:00:00 +0000
@@ -1,156 +0,0 @@
-# Copyright (c) 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: objectpath.py 1833 2005-12-17 00:58:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1833 $'
-
-import re
-
-from resolver import *
-
-__all__ = ['ObjectPathResolver', 'expose']
-
-class NoDefault(object):
-    pass
-
-class ObjectPathResolver(Resolver):
-    """
-    Inspired by CherryPy <http://www.cherrypy.org/>. :) For an explanation
-    of how this works, see the excellent tutorial at
-    <http://www.cherrypy.org/wiki/CherryPyTutorial>. We support the index and
-    default methods, though the calling convention for the default method
-    is different - we do not pass PATH_INFO as positional arguments. (It
-    is passed through the request/environ as normal.)
-
-    Also, we explicitly block certain function names. See below. I don't
-    know if theres really any harm in letting those attributes be followed,
-    but I'd rather not take the chance. And unfortunately, this solution
-    is pretty half-baked as well (I'd rather only allow certain object
-    types to be traversed, rather than disallow based on names.) Better
-    than nothing though...
-    """
-    index_page = 'index'
-    default_page = 'default'
-
-    def __init__(self, root, index=NoDefault, default=NoDefault,
-                 favorIndex=True):
-        """
-        root is the root object of your URL hierarchy. In CherryPy, this
-        would be cpg.root.
-
-        When the last component of a path has an index method and some
-        object along the path has a default method, favorIndex determines
-        which method is called when the URL has a trailing slash. If
-        True, the index method will be called. Otherwise, the default method.
-        """
-        self.root = root
-        if index is not NoDefault:
-            self.index_page = index
-        if default is not NoDefault:
-            self.default_page = default
-        self._favorIndex = favorIndex
-
-    # Certain names should be disallowed for safety. If one of your pages
-    # is showing up unexpectedly as a 404, make sure the function name doesn't
-    # begin with one of these prefixes.
-    _disallowed = re.compile(r'''(?:_|im_|func_|tb_|f_|co_).*''')
-
-    def _exposed(self, obj, redirect):
-        # If redirecting, allow non-exposed objects as well.
-        return callable(obj) and (getattr(obj, 'exposed', False) or redirect)
-
-    def resolve(self, request, redirect=False):
-        path_info = request.pathInfo.split(';')[0]
-        path_info = path_info.split('/')
-
-        assert len(path_info) > 0
-        assert not path_info[0]
-
-        current = self.root
-        current_default = None
-        i = 0
-        for i in range(1, len(path_info)):
-            component = path_info[i]
-
-            # See if we have an index page (needed for index/default
-            # disambiguation, unfortunately).
-            current_index = None
-            if self.index_page:
-                current_index = getattr(current, self.index_page, None)
-                if not self._exposed(current_index, redirect):
-                    current_index = None
-
-            if self.default_page:
-                # Remember the last default page we've seen.
-                new_default = getattr(current, self.default_page, None)
-                if self._exposed(new_default, redirect):
-                    current_default = (i - 1, new_default)
-
-            # Test for trailing slash.
-            if not component and current_index is not None and \
-               (self._favorIndex or current_default is None):
-                # Breaking out of the loop here favors index over default.
-                break
-
-            # Respect __all__ attribute. (Ok to generalize to all objects?)
-            all = getattr(current, '__all__', None)
-
-            current = getattr(current, component, None)
-            # Path doesn't exist
-            if current is None or self._disallowed.match(component) or \
-               (all is not None and component not in all and not redirect):
-                # Use path up to latest default page.
-                if current_default is not None:
-                    i, current = current_default
-                    break
-                # No default at all, so we fail.
-                return None
-
-        func = None
-        if self._exposed(current, redirect): # Exposed?
-            func = current
-        else:
-            # If not, see if it as an exposed index page
-            if self.index_page:
-                index = getattr(current, self.index_page, None)
-                if self._exposed(index, redirect): func = index
-            # How about a default page?
-            if func is None and self.default_page:
-                default = getattr(current, self.default_page, None)
-                if self._exposed(default, redirect): func = default
-            # Lastly, see if we have an ancestor's default page to fall back on.
-            if func is None and current_default is not None:
-                i, func = current_default
-
-        if func is not None:
-            self._updatePath(request, i)
-
-        return func
-
-def expose(func):
-    """Decorator to expose functions."""
-    func.exposed = True
-    return func

=== removed file 'flup/resolver/resolver.py'
--- flup/resolver/resolver.py	2006-06-28 13:43:41 +0000
+++ flup/resolver/resolver.py	1970-01-01 00:00:00 +0000
@@ -1,79 +0,0 @@
-# Copyright (c) 2002, 2005 Allan Saddi <allan@saddi.com>
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $Id: resolver.py 1833 2005-12-17 00:58:10Z asaddi $
-
-__author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1833 $'
-
-__all__ = ['Resolver']
-
-class Resolver(object):
-    """
-    Abstract base class for 'Resolver' objects. (An instance of which is
-    passed to Publisher's constructor.)
-
-    Given a Request, either return a callable (Publisher expects it to
-    be a function, method, class, or callable instance), or return None.
-    Typically Request.pathInfo is used to resolve the function.
-    Request.environ may be modified by the Resolver, for example, to re-adjust
-    SCRIPT_NAME/PATH_INFO after successful resolution. It is NOT recommended
-    that it be modified if resolution fails.
-
-    When resolving an InternalRedirect, redirect will be True.
-    """
-    def resolve(self, request, redirect=False):
-        raise NotImplementedError, self.__class__.__name__ + '.resolve'
-
-    def _updatePath(self, request, num):
-        """
-        Utility function to update SCRIPT_NAME and PATH_INFO in a sane
-        manner. Transfers num components from PATH_INFO to SCRIPT_NAME.
-        Keeps URL path parameters intact.
-        """
-        assert num >= 0
-        if not num:
-            return # Nothing to do
-        numScriptName = len(request.scriptName.split('/'))
-        totalPath = request.scriptName + request.pathInfo
-        if __debug__:
-            origTotalPath = totalPath
-        # Extract and save params
-        i = totalPath.find(';')
-        if i >= 0:
-            params = totalPath[i:]
-            totalPath = totalPath[:i]
-        else:
-            params = ''
-        totalPath = totalPath.split('/')
-        scriptName = '/'.join(totalPath[:numScriptName + num])
-        pathInfo = '/'.join([''] + totalPath[numScriptName + num:])
-        # SCRIPT_NAME shouldn't have trailing slash
-        if scriptName.endswith('/'):
-            scriptName = scriptName[:-1]
-            # Transfer to PATH_INFO (most likely empty, but just to be safe...)
-            pathInfo = '/' + pathInfo
-        request.environ['SCRIPT_NAME'] = scriptName
-        request.environ['PATH_INFO'] = pathInfo + params
-        assert request.scriptName + request.pathInfo == origTotalPath

=== modified file 'flup/server/ajp.py'
--- flup/server/ajp.py	2006-06-28 13:43:41 +0000
+++ flup/server/ajp.py	2007-09-12 20:22:04 +0000
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: ajp.py 1839 2006-02-24 00:16:10Z asaddi $
+# $Id: ajp.py 2188 2006-12-05 22:11:45Z asaddi $
 
 """
 ajp - an AJP 1.3/WSGI gateway.
@@ -77,13 +77,13 @@
 """
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1839 $'
+__version__ = '$Revision: 2188 $'
 
 import socket
 import logging
 
-from ajp_base import BaseAJPServer, Connection
-from threadedserver import ThreadedServer
+from flup.server.ajp_base import BaseAJPServer, Connection
+from flup.server.threadedserver import ThreadedServer
 
 __all__ = ['WSGIServer']
 
@@ -193,6 +193,8 @@
         yield '</table>\n' \
               '</body></html>\n'
 
+    from wsgiref import validate
+    test_app = validate.validator(test_app)
     # Explicitly set bindAddress to *:8009 for testing.
     WSGIServer(test_app,
                bindAddress=('', 8009), allowedServers=None,

=== modified file 'flup/server/ajp_base.py'
--- flup/server/ajp_base.py	2006-06-28 13:43:41 +0000
+++ flup/server/ajp_base.py	2007-09-12 20:22:04 +0000
@@ -22,10 +22,10 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: ajp_base.py 2015 2006-06-18 16:04:44Z asaddi $
+# $Id: ajp_base.py 2188 2006-12-05 22:11:45Z asaddi $
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2015 $'
+__version__ = '$Revision: 2188 $'
 
 import sys
 import socket
@@ -398,15 +398,15 @@
                     newPos = self._avail
                     break
                 else:
+                    if length is not None and len(self._buf) >= length + self._pos:
+                        newPos = self._pos + length
+                        break
                     # Wait for more to come.
                     self._waitForData()
                     continue
             else:
                 newPos = i + 1
                 break
-        if length is not None:
-            if self._pos + length < newPos:
-                newPos = self._pos + length
         r = self._buf[self._pos:newPos]
         self._pos = newPos
         self._shrinkBuffer()
@@ -924,6 +924,9 @@
         environ['PATH_INFO'] = value[len(scriptName):]
         environ['SCRIPT_NAME'] = scriptName
 
+        if not environ.has_key('QUERY_STRING'):
+            environ['QUERY_STRING'] = ''
+
     def error(self, request):
         """
         Override to provide custom error handling. Ideally, however,

=== modified file 'flup/server/ajp_fork.py'
--- flup/server/ajp_fork.py	2006-06-28 13:43:41 +0000
+++ flup/server/ajp_fork.py	2007-09-12 20:22:04 +0000
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: ajp_fork.py 1839 2006-02-24 00:16:10Z asaddi $
+# $Id: ajp_fork.py 2188 2006-12-05 22:11:45Z asaddi $
 
 """
 ajp - an AJP 1.3/WSGI gateway.
@@ -77,13 +77,13 @@
 """
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1839 $'
+__version__ = '$Revision: 2188 $'
 
 import socket
 import logging
 
-from ajp_base import BaseAJPServer, Connection
-from preforkserver import PreforkServer
+from flup.server.ajp_base import BaseAJPServer, Connection
+from flup.server.preforkserver import PreforkServer
 
 __all__ = ['WSGIServer']
 
@@ -191,6 +191,8 @@
         yield '</table>\n' \
               '</body></html>\n'
 
+    from wsgiref import validate
+    test_app = validate.validator(test_app)
     # Explicitly set bindAddress to *:8009 for testing.
     WSGIServer(test_app,
                bindAddress=('', 8009), allowedServers=None,

=== added file 'flup/server/cgi.py'
--- flup/server/cgi.py	1970-01-01 00:00:00 +0000
+++ flup/server/cgi.py	2007-09-12 20:22:04 +0000
@@ -0,0 +1,71 @@
+# Taken from <http://www.python.org/dev/peps/pep-0333/>
+# which was placed in the public domain.
+
+import os, sys
+
+
+__all__ = ['WSGIServer']
+
+
+class WSGIServer(object):
+
+    def __init__(self, application):
+        self.application = application
+
+    def run(self):
+
+        environ = dict(os.environ.items())
+        environ['wsgi.input']        = sys.stdin
+        environ['wsgi.errors']       = sys.stderr
+        environ['wsgi.version']      = (1,0)
+        environ['wsgi.multithread']  = False
+        environ['wsgi.multiprocess'] = True
+        environ['wsgi.run_once']     = True
+
+        if environ.get('HTTPS','off') in ('on','1'):
+            environ['wsgi.url_scheme'] = 'https'
+        else:
+            environ['wsgi.url_scheme'] = 'http'
+
+        headers_set = []
+        headers_sent = []
+
+        def write(data):
+            if not headers_set:
+                 raise AssertionError("write() before start_response()")
+
+            elif not headers_sent:
+                 # Before the first output, send the stored headers
+                 status, response_headers = headers_sent[:] = headers_set
+                 sys.stdout.write('Status: %s\r\n' % status)
+                 for header in response_headers:
+                     sys.stdout.write('%s: %s\r\n' % header)
+                 sys.stdout.write('\r\n')
+
+            sys.stdout.write(data)
+            sys.stdout.flush()
+
+        def start_response(status,response_headers,exc_info=None):
+            if exc_info:
+                try:
+                    if headers_sent:
+                        # Re-raise original exception if headers sent
+                        raise exc_info[0], exc_info[1], exc_info[2]
+                finally:
+                    exc_info = None     # avoid dangling circular ref
+            elif headers_set:
+                raise AssertionError("Headers already set!")
+
+            headers_set[:] = [status,response_headers]
+            return write
+
+        result = self.application(environ, start_response)
+        try:
+            for data in result:
+                if data:    # don't send headers until body appears
+                    write(data)
+            if not headers_sent:
+                write('')   # send headers now if body was empty
+        finally:
+            if hasattr(result,'close'):
+                result.close()

=== modified file 'flup/server/fcgi.py'
--- flup/server/fcgi.py	2006-11-28 18:53:39 +0000
+++ flup/server/fcgi.py	2007-09-12 20:22:04 +0000
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: fcgi.py 2030 2006-08-28 16:45:53Z asaddi $
+# $Id: fcgi.py 2188 2006-12-05 22:11:45Z asaddi $
 
 """
 fcgi - a FastCGI/WSGI gateway.
@@ -47,12 +47,12 @@
 """
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2030 $'
+__version__ = '$Revision: 2188 $'
 
 import os
 
-from fcgi_base import BaseFCGIServer, FCGI_RESPONDER
-from threadedserver import ThreadedServer
+from flup.server.fcgi_base import BaseFCGIServer, FCGI_RESPONDER
+from flup.server.threadedserver import ThreadedServer
 
 __all__ = ['WSGIServer']
 
@@ -147,4 +147,6 @@
         yield '</table>\n' \
               '</body></html>\n'
 
+    from wsgiref import validate
+    test_app = validate.validator(test_app)
     WSGIServer(test_app).run()

=== modified file 'flup/server/fcgi_base.py'
--- flup/server/fcgi_base.py	2006-11-28 18:53:39 +0000
+++ flup/server/fcgi_base.py	2007-09-12 20:22:04 +0000
@@ -22,10 +22,10 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: fcgi_base.py 2030 2006-08-28 16:45:53Z asaddi $
+# $Id: fcgi_base.py 2348 2007-05-11 16:52:46Z asaddi $
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2030 $'
+__version__ = '$Revision: 2348 $'
 
 import sys
 import os
@@ -189,15 +189,15 @@
                     newPos = self._avail
                     break
                 else:
+                    if length is not None and len(self._buf) >= length + self._pos:
+                        newPos = self._pos + length
+                        break
                     # Wait for more to come.
                     self._waitForData()
                     continue
             else:
                 newPos = i + 1
                 break
-        if length is not None:
-            if self._pos + length < newPos:
-                newPos = self._pos + length
         r = self._buf[self._pos:newPos]
         self._pos = newPos
         self._shrinkBuffer()
@@ -567,8 +567,12 @@
         if __debug__: _debug(1, 'protocolStatus = %d, appStatus = %d' %
                              (protocolStatus, appStatus))
 
-        self._flush()
-        self._end(appStatus, protocolStatus)
+        try:
+            self._flush()
+            self._end(appStatus, protocolStatus)
+        except socket.error, e:
+            if e[0] != errno.EPIPE:
+                raise
 
     def _end(self, appStatus=0L, protocolStatus=FCGI_REQUEST_COMPLETE):
         self._conn.end_request(self, appStatus, protocolStatus)
@@ -1134,6 +1138,8 @@
             environ['SCRIPT_NAME'] = ''
         if not environ.has_key('PATH_INFO'):
             environ['PATH_INFO'] = ''
+        if not environ.has_key('QUERY_STRING'):
+            environ['QUERY_STRING'] = ''
 
         # If any of these are missing, it probably signifies a broken
         # server...

=== modified file 'flup/server/fcgi_fork.py'
--- flup/server/fcgi_fork.py	2006-06-28 13:43:41 +0000
+++ flup/server/fcgi_fork.py	2007-09-12 20:22:04 +0000
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: fcgi_fork.py 1968 2006-05-18 16:31:12Z asaddi $
+# $Id: fcgi_fork.py 2349 2007-05-17 16:08:55Z asaddi $
 
 """
 fcgi - a FastCGI/WSGI gateway.
@@ -47,13 +47,13 @@
 """
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 1968 $'
+__version__ = '$Revision: 2349 $'
 
 import os
 
-from fcgi_base import BaseFCGIServer
-from fcgi_base import FCGI_MAX_CONNS, FCGI_MAX_REQS, FCGI_MPXS_CONNS
-from preforkserver import PreforkServer
+from flup.server.fcgi_base import BaseFCGIServer, \
+     FCGI_MAX_CONNS, FCGI_MAX_REQS, FCGI_MPXS_CONNS
+from flup.server.preforkserver import PreforkServer
 
 __all__ = ['WSGIServer']
 
@@ -97,9 +97,12 @@
             import resource
             # Attempt to glean the maximum number of connections
             # from the OS.
-            maxProcs = resource.getrlimit(resource.RLIMIT_NPROC)[0]
-            maxConns = resource.getrlimit(resource.RLIMIT_NOFILE)[0]
-            maxConns = min(maxConns, maxProcs)
+            try:
+                maxProcs = resource.getrlimit(resource.RLIMIT_NPROC)[0]
+                maxConns = resource.getrlimit(resource.RLIMIT_NOFILE)[0]
+                maxConns = min(maxConns, maxProcs)
+            except AttributeError:
+                maxConns = resource.getrlimit(resource.RLIMIT_NOFILE)[0]
         except ImportError:
             maxConns = 100 # Just some made up number.
         maxReqs = maxConns
@@ -162,4 +165,6 @@
         yield '</table>\n' \
               '</body></html>\n'
 
+    from wsgiref import validate
+    test_app = validate.validator(test_app)
     WSGIServer(test_app).run()

=== modified file 'flup/server/preforkserver.py'
--- flup/server/preforkserver.py	2006-06-28 13:43:41 +0000
+++ flup/server/preforkserver.py	2007-09-12 20:22:04 +0000
@@ -22,10 +22,10 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: preforkserver.py 2016 2006-06-27 18:53:47Z asaddi $
+# $Id: preforkserver.py 2311 2007-01-23 00:05:04Z asaddi $
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2016 $'
+__version__ = '$Revision: 2311 $'
 
 import sys
 import os
@@ -34,11 +34,20 @@
 import errno
 import signal
 
+try:
+    import fcntl
+except ImportError:
+    def setCloseOnExec(sock):
+        pass
+else:
+    def setCloseOnExec(sock):
+        fcntl.fcntl(sock.fileno(), fcntl.F_SETFD, fcntl.FD_CLOEXEC)
+
 # If running Python < 2.4, require eunuchs module for socket.socketpair().
 # See <http://www.inoi.fi/open/trac/eunuchs>.
 if not hasattr(socket, 'socketpair'):
     try:
-        import eunuchs
+        import eunuchs.socketpair
     except ImportError:
         # TODO: Other alternatives? Perhaps using os.pipe()?
         raise ImportError, 'Requires eunuchs module for Python < 2.4'
@@ -53,15 +62,6 @@
 
     socket.socketpair = socketpair
 
-try:
-    import fcntl
-except ImportError:
-    def setCloseOnExec(sock):
-        pass
-else:
-    def setCloseOnExec(sock):
-        fcntl.fcntl(sock.fileno(), fcntl.F_SETFD, fcntl.FD_CLOEXEC)
-
 class PreforkServer(object):
     """
     A preforked server model conceptually similar to Apache httpd(2). At

=== modified file 'flup/server/scgi.py'
--- flup/server/scgi.py	2006-11-28 18:53:39 +0000
+++ flup/server/scgi.py	2007-09-12 20:22:04 +0000
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: scgi.py 2111 2006-11-25 02:00:21Z asaddi $
+# $Id: scgi.py 2306 2007-01-02 22:15:53Z asaddi $
 
 """
 scgi - an SCGI/WSGI gateway.
@@ -61,13 +61,13 @@
 """
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2111 $'
+__version__ = '$Revision: 2306 $'
 
 import logging
 import socket
 
-from scgi_base import BaseSCGIServer, Connection
-from threadedserver import ThreadedServer
+from flup.server.scgi_base import BaseSCGIServer, Connection, NoDefault
+from flup.server.threadedserver import ThreadedServer
 
 __all__ = ['WSGIServer']
 
@@ -87,7 +87,7 @@
     of preforking to be quite superior. So if your application really doesn't
     mind running in multiple processes, go use SWAP. ;)
     """
-    def __init__(self, application, scriptName='', environ=None,
+    def __init__(self, application, scriptName=NoDefault, environ=None,
                  multithreaded=True, multiprocess=False,
                  bindAddress=('localhost', 4000), umask=None,
                  allowedServers=None,
@@ -188,5 +188,7 @@
         yield '</table>\n' \
               '</body></html>\n'
 
+    from wsgiref import validate
+    test_app = validate.validator(test_app)
     WSGIServer(test_app,
                loggingLevel=logging.DEBUG).run()

=== modified file 'flup/server/scgi_base.py'
--- flup/server/scgi_base.py	2006-11-28 18:53:39 +0000
+++ flup/server/scgi_base.py	2007-09-12 20:22:04 +0000
@@ -22,10 +22,10 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: scgi_base.py 2113 2006-11-25 02:08:55Z asaddi $
+# $Id: scgi_base.py 2306 2007-01-02 22:15:53Z asaddi $
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2113 $'
+__version__ = '$Revision: 2306 $'
 
 import sys
 import logging
@@ -36,6 +36,7 @@
 import signal
 import datetime
 import os
+import warnings
 
 # Threads are required. If you want a non-threaded (forking) version, look at
 # SWAP <http://www.idyll.org/~t/www-tools/wsgi/>.
@@ -273,7 +274,7 @@
     # What Request class to use.
     requestClass = Request
 
-    def __init__(self, application, scriptName='', environ=None,
+    def __init__(self, application, scriptName=NoDefault, environ=None,
                  multithreaded=True, multiprocess=False,
                  bindAddress=('localhost', 4000), umask=None,
                  allowedServers=NoDefault,
@@ -471,26 +472,45 @@
 
     def _sanitizeEnv(self, environ):
         """Fill-in/deduce missing values in environ."""
-        # Namely SCRIPT_NAME/PATH_INFO
+        # Ensure QUERY_STRING exists
+        if not environ.has_key('QUERY_STRING'):
+            environ['QUERY_STRING'] = ''
+
+        # Check WSGI_SCRIPT_NAME
         scriptName = environ.get('WSGI_SCRIPT_NAME')
         if scriptName is None:
             scriptName = self.scriptName
-        elif scriptName.lower() == 'none':
-            scriptName = None
+        else:
+            warnings.warn('WSGI_SCRIPT_NAME environment variable for scgi '
+                          'servers is deprecated',
+                          DeprecationWarning)
+            if scriptName.lower() == 'none':
+                scriptName = None
 
         if scriptName is None:
             # Do nothing (most likely coming from cgi2scgi)
             return
 
-        value = environ['SCRIPT_NAME']
-        # Pull PATH_INFO from environ, if it exists. (cgi2scgi actually
-        # passes it in.)
-        value += environ.get('PATH_INFO', '')
-        if not value.startswith(scriptName):
-            self.logger.warning('scriptName does not match request URI')
-
-        environ['PATH_INFO'] = value[len(scriptName):]
-        environ['SCRIPT_NAME'] = scriptName
+        if scriptName is NoDefault:
+            # Pull SCRIPT_NAME/PATH_INFO from environment, with empty defaults
+            if not environ.has_key('SCRIPT_NAME'):
+                environ['SCRIPT_INFO'] = ''
+            if not environ.has_key('PATH_INFO'):
+                environ['PATH_INFO'] = ''
+        else:
+            # Configured scriptName
+            warnings.warn('Configured SCRIPT_NAME is deprecated\n'
+                          'Do not use WSGI_SCRIPT_NAME or the scriptName\n'
+                          'keyword parameter -- they will be going away',
+                          DeprecationWarning)
+
+            value = environ['SCRIPT_NAME']
+            value += environ.get('PATH_INFO', '')
+            if not value.startswith(scriptName):
+                self.logger.warning('scriptName does not match request URI')
+
+            environ['PATH_INFO'] = value[len(scriptName):]
+            environ['SCRIPT_NAME'] = scriptName
 
     def error(self, request):
         """

=== modified file 'flup/server/scgi_fork.py'
--- flup/server/scgi_fork.py	2006-11-28 18:53:39 +0000
+++ flup/server/scgi_fork.py	2007-09-12 20:22:04 +0000
@@ -22,7 +22,7 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: scgi_fork.py 2111 2006-11-25 02:00:21Z asaddi $
+# $Id: scgi_fork.py 2306 2007-01-02 22:15:53Z asaddi $
 
 """
 scgi - an SCGI/WSGI gateway.
@@ -61,13 +61,13 @@
 """
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2111 $'
+__version__ = '$Revision: 2306 $'
 
 import logging
 import socket
 
-from scgi_base import BaseSCGIServer, Connection
-from preforkserver import PreforkServer
+from flup.server.scgi_base import BaseSCGIServer, Connection, NoDefault
+from flup.server.preforkserver import PreforkServer
 
 __all__ = ['WSGIServer']
 
@@ -87,7 +87,7 @@
     of preforking to be quite superior. So if your application really doesn't
     mind running in multiple processes, go use SWAP. ;)
     """
-    def __init__(self, application, scriptName='', environ=None,
+    def __init__(self, application, scriptName=NoDefault, environ=None,
                  bindAddress=('localhost', 4000), umask=None,
                  allowedServers=None,
                  loggingLevel=logging.INFO, debug=True, **kw):
@@ -186,5 +186,7 @@
         yield '</table>\n' \
               '</body></html>\n'
 
+    from wsgiref import validate
+    test_app = validate.validator(test_app)
     WSGIServer(test_app,
                loggingLevel=logging.DEBUG).run()

=== modified file 'flup/server/threadedserver.py'
--- flup/server/threadedserver.py	2006-11-28 18:53:39 +0000
+++ flup/server/threadedserver.py	2007-09-12 20:22:04 +0000
@@ -22,10 +22,10 @@
 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 # SUCH DAMAGE.
 #
-# $Id: threadedserver.py 2126 2006-11-27 06:30:15Z asaddi $
+# $Id: threadedserver.py 2174 2006-12-02 23:26:13Z asaddi $
 
 __author__ = 'Allan Saddi <allan@saddi.com>'
-__version__ = '$Revision: 2126 $'
+__version__ = '$Revision: 2174 $'
 
 import sys
 import socket
@@ -33,8 +33,6 @@
 import signal
 import errno
 
-from threadpool import ThreadPool
-
 try:
     import fcntl
 except ImportError:
@@ -44,6 +42,8 @@
     def setCloseOnExec(sock):
         fcntl.fcntl(sock.fileno(), fcntl.F_SETFD, fcntl.FD_CLOEXEC)
 
+from flup.server.threadpool import ThreadPool
+
 __all__ = ['ThreadedServer']
 
 class ThreadedServer(object):

=== modified file 'flup/server/threadpool.py'
--- flup/server/threadpool.py	2006-06-28 13:43:41 +0000
+++ flup/server/threadpool.py	2007-09-12 20:22:04 +0000
@@ -100,7 +100,12 @@
 
             self._lock.release()
 
-            job.run()
+            try:
+                job.run()
+            except:
+                # FIXME: This should really be reported somewhere.
+                # But we can't simply report it to stderr because of fcgi
+                pass
 
             self._lock.acquire()
 

=== added file 'setup.cfg'
--- setup.cfg	1970-01-01 00:00:00 +0000
+++ setup.cfg	2007-09-12 20:22:04 +0000
@@ -0,0 +1,5 @@
+[egg_info]
+tag_build = 
+tag_date = 0
+tag_svn_revision = 0
+

=== modified file 'setup.py'
--- setup.py	2006-11-28 18:53:39 +0000
+++ setup.py	2007-09-12 20:22:04 +0000
@@ -1,30 +1,40 @@
-#!/usr/bin/env python
-
-setuptools_extras = {}
-
-try:
-    from setuptools import setup
-    setuptools_extras['entry_points'] = """
-        [paste.server_factory]
-        ajp = flup.server.ajp:factory
-        fcgi = flup.server.fcgi:factory
-        scgi = flup.server.scgi:factory
-        ajp_thread = flup.server.ajp:factory
-        fcgi_thread = flup.server.fcgi:factory
-        scgi_thread = flup.server.scgi:factory
-        ajp_fork = flup.server.ajp_fork:factory
-        fcgi_fork = flup.server.fcgi_fork:factory
-        scgi_fork = flup.server.scgi_fork:factory
-        """
-except ImportError:
-    from distutils.core import setup
-
-setup(name='flup',
-      version='0.5',
-      description='Random assortment of WSGI servers, middleware',
-      author='Allan Saddi',
-      author_email='allan@saddi.com',
-      url='http://www.saddi.com/software/flup/',
-      packages=['flup', 'flup.client', 'flup.middleware', 'flup.resolver',
-                'flup.server'],
-      **setuptools_extras)
+# Bootstrap setuptools
+from ez_setup import use_setuptools
+use_setuptools()
+
+from setuptools import setup, find_packages
+setup(
+    name = 'flup',
+    version = '1.0',
+    packages = find_packages(),
+    zip_safe = True,
+    
+    entry_points = """
+    [paste.server_factory]
+    ajp = flup.server.ajp:factory
+    fcgi = flup.server.fcgi:factory
+    scgi = flup.server.scgi:factory
+    ajp_thread = flup.server.ajp:factory
+    fcgi_thread = flup.server.fcgi:factory
+    scgi_thread = flup.server.scgi:factory
+    ajp_fork = flup.server.ajp_fork:factory
+    fcgi_fork = flup.server.fcgi_fork:factory
+    scgi_fork = flup.server.scgi_fork:factory
+    """,
+    
+    author = 'Allan Saddi',
+    author_email = 'allan@saddi.com',
+    description = 'Random assortment of WSGI servers',
+    license = 'BSD',
+    url='http://www.saddi.com/software/flup/',
+    classifiers = [
+    'Development Status :: 5 - Production/Stable',
+    'Environment :: Web Environment',
+    'Intended Audience :: Developers',
+    'License :: OSI Approved :: BSD License',
+    'Operating System :: OS Independent',
+    'Programming Language :: Python',
+    'Topic :: Internet :: WWW/HTTP :: WSGI :: Server',
+    'Topic :: Software Development :: Libraries :: Python Modules',
+    ],
+    )

